#include "BlockDevice.h"
#include "Kernel.h"
#include "ATADriver.h"

/*==============================class Devtab===================================*/
/* 豸devtabʵΪϵͳATAӲһ豸*/
Devtab g_Atab;

Devtab::Devtab()
{
	this->d_active = 0;
	this->d_errcnt = 0;
	this->b_forw = NULL;
	this->b_back = NULL;
	this->d_actf = NULL;
	this->d_actl = NULL;
}

Devtab::~Devtab()
{
	//nothing to do here
}

/*==============================class BlockDevice===============================*/
BlockDevice::BlockDevice()
{
	//nothing to do here
}

BlockDevice::BlockDevice(Devtab* pDevtab)
{	
	this->d_tab = pDevtab;
	if(this->d_tab != NULL)
	{
		this->d_tab->b_forw = (Buf *)this->d_tab;
		this->d_tab->b_back = (Buf *)this->d_tab;
	}
}

BlockDevice::~BlockDevice()
{
	//nothing to do here
}

int BlockDevice::Open(short dev, int mode)
{
	Utility::Panic("ERROR! Base Class: BlockDevice::Open()!");
	return 0;	/* GCC likes it ! */
}

int BlockDevice::Close(short dev, int mode)
{
	Utility::Panic("ERROR! Base Class: BlockDevice::Close()!");
	return 0;	/* GCC likes it ! */
}

int BlockDevice::Strategy(Buf *bp)
{
	Utility::Panic("ERROR! Base Class: BlockDevice::Strategy()!");
	return 0;	/* GCC likes it ! */
}

void BlockDevice::Start()
{
	Utility::Panic("ERROR! Base Class: BlockDevice::Start()!");
}

/*=============================class ATABlockDevice=============================*/
/* ATABlockDeviceʵ
 * ʵoverride豸BlockDeviceOpen(), Close(), Strategy()麯
 */
ATABlockDevice g_ATADevice(&g_Atab);

/* 
 * !hard code!bochs´ӳļc.imgСӦϵͳʱȡ
 * 20 Cylinders; 16 Heads; 63 Sectors/Track20 * 16 * 63 = 20160 Sectors
 * c.img: 10,321,920 bytes = 10,008KB 
 */
int ATABlockDevice::NSECTOR = 0x7FFFFFFF;	/* Max Possible Sector Numbers */

ATABlockDevice::ATABlockDevice(Devtab* pDevtab)
	:BlockDevice(pDevtab)
{
}

ATABlockDevice::~ATABlockDevice()
{
	//nothing to do here
}

int ATABlockDevice::Open(short dev, int mode)
{
	return 0;	/* GCC likes it ! */
}

int ATABlockDevice::Close(short dev, int mode)
{
	return 0;	/* GCC likes it ! */
}

int ATABlockDevice::Strategy(Buf* bp)
{
	/* I/OǷ񳬳˸Ӳ̵ */
	if(bp->b_blkno >= ATABlockDevice::NSECTOR)
	{
		/* ó־ */
		bp->b_flags |= Buf::B_ERROR;

		BufferManager& bm = Kernel::Instance().GetBufferManager();
		/* 
		 * ²ִI/O൱ģж
		 * еIODone()ѵȴI/OĽ̡
		 */
		bm.IODone(bp);
		return 0;	/* GCC likes it ! */
	}

	/* bpI/OеĶβʱI/OѾ˻ʽbp->av_forw־β */
	bp->av_forw = NULL;

	/* ²ٽٽԴΪ豸g_Atab
	 * ΪԿ豸g_AtabI/Oнв
	 * жϴҲI/Oвǲеġ
	 * ʵֻرӲ̵жϾͿˡ
	 */
	X86Assembly::CLI();
	if(this->d_tab->d_actf == NULL)
	{
		this->d_tab->d_actf = bp;
	}
	else
	{
		this->d_tab->d_actl->av_forw = bp;
	}
	this->d_tab->d_actl = bp;

	/* Ӳ̲æӲ̲򽫵ǰI/O
	 * 豸I/Oֱ֮ӷأǰ̵I/Oɺ
	 * CPUжϣϵͳڴжϴִп豸
	 * I/OеһI/O
	 */
	if(this->d_tab->d_active == 0)		/* ̿ */
	{
		this->Start();
	}
	X86Assembly::STI();

	return 0;	/* GCC likes it ! */
}

void ATABlockDevice::Start()
{
	Buf* bp;

	if( (bp = this->d_tab->d_actf) == 0 )
		return;		/* I/OΪգ */

	this->d_tab->d_active++;	/* I/Oвգÿæ־ */

	/* ô̼ĴI/O */
	ATADriver::DevStart(bp);
}
