#include "BufferManager.h"
#include "Kernel.h"

BufferManager::BufferManager()
{
	//nothing to do here
}

BufferManager::~BufferManager()
{
	//nothing to do here
}

void BufferManager::Initialize()
{
	int i;
	Buf* bp;

	this->bFreeList.b_forw = this->bFreeList.b_back = &(this->bFreeList);
	this->bFreeList.av_forw = this->bFreeList.av_back = &(this->bFreeList);

	for(i = 0; i < NBUF; i++)
	{
		bp = &(this->m_Buf[i]);
		bp->b_dev = -1;
		bp->b_addr = this->Buffer[i];
		/* ʼNODEV */
		bp->b_back = &(this->bFreeList);
		bp->b_forw = this->bFreeList.b_forw;
		this->bFreeList.b_forw->b_back = bp;
		this->bFreeList.b_forw = bp;
		/* ʼɶ */
		bp->b_flags = Buf::B_BUSY;
		Brelse(bp);
	}
	this->m_DeviceManager = &Kernel::Instance().GetDeviceManager();
	return;
}

Buf* BufferManager::GetBlk(short dev, int blkno)
{
	Buf* bp;
	Devtab* dp;
	User& u = Kernel::Instance().GetUser();

	/* 豸ųϵͳп豸 */
	if( Utility::GetMajor(dev) >= this->m_DeviceManager->GetNBlkDev() )
	{
		Utility::Panic("nblkdev: There doesn't exist the device");
	}

	/* 
	 * 豸ѾӦ棬򷵻ظû棻
	 * ɶзµĻַд
	 */
loop:
	/* ʾNODEV豸ַ */
	if(dev < 0)
	{
		dp = (Devtab *)(&this->bFreeList);
	}
	else
	{
		short major = Utility::GetMajor(dev);
		/* 豸Żÿ豸 */
		dp = this->m_DeviceManager->GetBlockDevice(major).d_tab;

		if(dp == NULL)
		{
			Utility::Panic("Null devtab!");
		}
		/* ڸ豸ǷӦĻ */
		for(bp = dp->b_forw; bp != (Buf *)dp; bp = bp->b_forw)
		{
			/* ҪҵĻ棬 */
			if(bp->b_blkno != blkno || bp->b_dev != dev)
				continue;

			/* 
			 * ٽ֮Ҫ￪ʼǴforѭʼ
			 * ҪΪжϷ򲢲ȥ޸Ŀ豸е
			 * 豸buf(b_forw)Բͻ
			 */
			X86Assembly::CLI();
			if(bp->b_flags & Buf::B_BUSY)
			{
				bp->b_flags |= Buf::B_WANTED;
				u.u_procp->Sleep((unsigned long)bp, ProcessManager::PRIBIO);
				X86Assembly::STI();
				goto loop;
			}
			X86Assembly::STI();
			/* ɶгȡ */
			this->NotAvail(bp);
			return bp;
		}
	}//end of else

	X86Assembly::CLI();
	/* ɶΪ */
	if(this->bFreeList.av_forw == &this->bFreeList)
	{
		this->bFreeList.b_flags |= Buf::B_WANTED;
		u.u_procp->Sleep((unsigned long)&this->bFreeList, ProcessManager::PRIBIO);
		X86Assembly::STI();
		goto loop;
	}
	X86Assembly::STI();

	/* ȡɶеһп */
	bp = this->bFreeList.av_forw;
	this->NotAvail(bp);

	/* ַӳд첽д */
	if(bp->b_flags & Buf::B_DELWRI)
	{
		bp->b_flags |= Buf::B_ASYNC;
		this->Bwrite(bp);
		goto loop;
	}
	/* ע: λֻB_BUSY */
	bp->b_flags = Buf::B_BUSY;

	/* ԭ豸г */
	bp->b_back->b_forw = bp->b_forw;
	bp->b_forw->b_back = bp->b_back;
	/* µ豸 */
	bp->b_forw = dp->b_forw;
	bp->b_back = (Buf *)dp;
	dp->b_forw->b_back = bp;
	dp->b_forw = bp;

	bp->b_dev = dev;
	bp->b_blkno = blkno;
	return bp;
}

void BufferManager::Brelse(Buf* bp)
{
	ProcessManager& procMgr = Kernel::Instance().GetProcessManager();

	if(bp->b_flags & Buf::B_WANTED)
	{
		procMgr.WakeUpAll((unsigned long)bp);
	}

	/* нڵȴɶеĻ棬Ӧ */
	if(this->bFreeList.b_flags & Buf::B_WANTED)
	{
		/* B_WANTED־ʾпл */
		this->bFreeList.b_flags &= (~Buf::B_WANTED);
		procMgr.WakeUpAll((unsigned long)&this->bFreeList);
	}

	/* д򽫴豸Ÿĵ
	 * ûеĴݡ
	 */
	if(bp->b_flags & Buf::B_ERROR)
	{
		Utility::SetMinor(bp->b_dev, -1);
	}

	/* ٽԴ磺ͬĩڻ
	 * ʱпܻжϣͬ
	 */
	X86Assembly::CLI();		/* spl6();  UNIX V6 */

	/* ע²ûB_DELWRIB_WRITEB_READB_DONE־
	 * B_DELWRIʾȻÿƿͷŵɶ棬пܻûЩϡ
	 * B_DONEָûȷطӳ˴洢ڻӦ洢ڴϵϢ 
	 */
	bp->b_flags &= ~(Buf::B_WANTED | Buf::B_BUSY | Buf::B_ASYNC);
	(this->bFreeList.av_back)->av_forw = bp;
	bp->av_back = this->bFreeList.av_back;
	bp->av_forw = &(this->bFreeList);
	this->bFreeList.av_back = bp;
	
	X86Assembly::STI();
	return;
}

void BufferManager::IOWait(Buf* bp)
{
	User& u = Kernel::Instance().GetUser();

	/* 漰ٽ
	 * Ϊִγʱ򣬺пܳӲжϣ
	 * ӲжУ޸B_DONEʱѾѭ
	 * ʹøĽԶ˯
	 */
	X86Assembly::CLI();
	while( (bp->b_flags & Buf::B_DONE) == 0 )
	{
		u.u_procp->Sleep((unsigned long)bp, ProcessManager::PRIBIO);
	}
	X86Assembly::STI();

	this->GetError(bp);
	return;
}

void BufferManager::IODone(Buf* bp)
{
	/* I/Oɱ־ */
	bp->b_flags |= Buf::B_DONE;
	if(bp->b_flags & Buf::B_ASYNC)
	{
		/* 첽,ͷŻ */
		this->Brelse(bp);
	}
	else
	{
		/* B_WANTED־λ */
		bp->b_flags &= (~Buf::B_WANTED);
		Kernel::Instance().GetProcessManager().WakeUpAll((unsigned long)bp);
	}
	return;
}

Buf* BufferManager::Bread(short dev, int blkno)
{
	Buf* bp;
	/* 豸ţַ뻺 */
	bp = this->GetBlk(dev, blkno);
	/* 豸ҵ軺棬B_DONEãͲI/O */
	if(bp->b_flags & Buf::B_DONE)
	{
		return bp;
	}
	/* ûҵӦ棬I/O */
	bp->b_flags |= Buf::B_READ;
	bp->b_wcount = BufferManager::BUFFER_SIZE;


	/* 
	 * I/OӦ豸I/OУI/OִбI/O
	 * ȴǰI/OִϺжϴִд
	 * עStrategy()I/O豸к󣬲I/Oִϣֱӷء
	 */
	this->m_DeviceManager->GetBlockDevice(Utility::GetMajor(dev)).Strategy(bp);
	/* ͬȴI/O */
	this->IOWait(bp);
	return bp;
}

Buf* BufferManager::Breada(short adev, int blkno, int rablkno)
{
	Buf* bp = NULL;	/* ԤַĻBuf */
	Buf* abp;		/* ԤַĻBuf */
	short major = Utility::GetMajor(adev);	/* 豸 */

	/* ǰַǷ豸Buf */
	if( !this->InCore(adev, blkno) )
	{
		bp = this->GetBlk(adev, blkno);		/* ûҵGetBlk()仺 */
		
		/* 䵽B_DONE־ãζInCore()֮
		 * ɶȡͬһַ飬GetBlk()ٴʱ
		 * ַָ豸BufлУøû档*/
		if( (bp->b_flags & Buf::B_DONE) == 0 )
		{
			/* ɶ */
			bp->b_flags |= Buf::B_READ;
			bp->b_wcount = BufferManager::BUFFER_SIZE;
			/* 豸I/O */
			this->m_DeviceManager->GetBlockDevice(major).Strategy(bp);
		}
	}
	else
		/*UNIX V6û䡣ԭǰڻУԤ
		 * ΪԤļֵõǰԤλôڽʵ
		 * ԤٴűƶЧ̶ǰڻأͷһڵǰڵλã
		 * ʱԤ*/
		rablkno = 0;

	/* Ԥ2ֵע⣺
	 * 1rablknoΪ0˵UNIXԤ
	 *      ǿȨ
	 * 2Ԥַ豸BufУԤĲѾɹ
	 * 		Ϊ
	 * 		ΪԤ飬ǽ̴˴ζ̵Ŀġ
	 * 		ʱͷţʹԤһֱòͷš
	 * 		ͷȻ豸Уڶʱ
	 * 		ʹһ飬ôȻҵ
	 * */
	if( rablkno && !this->InCore(adev, rablkno) )
	{
		abp = this->GetBlk(adev, rablkno);	/* ûҵGetBlk()仺 */
		
		/* B_DONE־λͬϡ */
		if(abp->b_flags & Buf::B_DONE)
		{
			/* ԤַڻУͷռõĻ档
			 * ΪδغһʹԤַ飬
			 * ҲͲȥͷŸû棬пܵ»Դ
			 * ĳʱռá
			 */
			this->Brelse(abp);
		}
		else
		{
			/* 첽Ԥַ */
			abp->b_flags |= (Buf::B_READ | Buf::B_ASYNC);
			abp->b_wcount = BufferManager::BUFFER_SIZE;
			/* 豸I/O */
			this->m_DeviceManager->GetBlockDevice(major).Strategy(abp);
		}
	}
	
	/* bp == NULLζInCore()ʱ̣Ԥ豸У
	 * InCore()ֻǡ顱ժȡһʱִе˴
	 * пַܸѾ·á
	 * µBread()ضַ飬Bread()еGetBlk()ַ顰ժȡ
	 * ʱڸַ豸УԴ˴Bread()һҲǽ
	 * ãִһI/Oȡ
	 */
	if(NULL == bp)
	{
		return (this->Bread(adev, blkno));
	}
	
	/* InCore()ʱδҵԤַ飬ȴI/O */
	this->IOWait(bp);
	return bp;
}

void BufferManager::Bwrite(Buf *bp)
{
	unsigned int flags;

	flags = bp->b_flags;
	bp->b_flags &= ~(Buf::B_READ | Buf::B_DONE | Buf::B_ERROR | Buf::B_DELWRI);
	bp->b_wcount = BufferManager::BUFFER_SIZE;		/* 512ֽ */

	this->m_DeviceManager->GetBlockDevice(Utility::GetMajor(bp->b_dev)).Strategy(bp);

	if( (flags & Buf::B_ASYNC) == 0 )
	{
		/* ͬдҪȴI/O */
		this->IOWait(bp);
		this->Brelse(bp);
	}
	else if( (flags & Buf::B_DELWRI) == 0)
	{
	/* 
	 * ӳд󣻷򲻼顣
	 * Ϊӳдпܵǰ̲
	 * һḶ̌GetError()Ҫ
	 * ǰ̸ϴ־
	 */
		this->GetError(bp);
	}
	return;
}

void BufferManager::Bdwrite(Buf *bp)
{
	/* B_DONEʹøô̿ */
	bp->b_flags |= (Buf::B_DELWRI | Buf::B_DONE);
	this->Brelse(bp);
	return;
}

void BufferManager::Bawrite(Buf *bp)
{
	/* Ϊ첽д */
	bp->b_flags |= Buf::B_ASYNC;
	this->Bwrite(bp);
	return;
}

void BufferManager::ClrBuf(Buf *bp)
{
	int* pInt = (int *)bp->b_addr;

	/*  */
	for(unsigned int i = 0; i < BufferManager::BUFFER_SIZE / sizeof(int); i++)
	{
		pInt[i] = 0;
	}
	return;
}

void BufferManager::Bflush(short dev)
{
	Buf* bp;
	/* ע⣺֮Ҫһ֮¿ʼ
	 * Ϊbwite()뵽ʱпжϵĲ
	 * ȵbwriteִɺCPUѴڿж״̬Ժ
	 * пڼжϣʹbfreelistгֱ仯
	 * ¿ʼôܿ
	 * bfreelistеʱִ
	 */
loop:
	X86Assembly::CLI();
	for(bp = this->bFreeList.av_forw; bp != &(this->bFreeList); bp = bp->av_forw)
	{
		/* ҳɶӳдĿ */
		if( (bp->b_flags & Buf::B_DELWRI) && (dev == DeviceManager::NODEV || dev == bp->b_dev) )
		{
			bp->b_flags |= Buf::B_ASYNC;
			this->NotAvail(bp);
			this->Bwrite(bp);
			goto loop;
		}
	}
	X86Assembly::STI();
	return;
}

bool BufferManager::Swap(int blkno, unsigned long addr, int count, enum Buf::BufFlag flag)
{
	User& u = Kernel::Instance().GetUser();

	X86Assembly::CLI();

	/* swbufڱʹã˯ߵȴ */
	while ( this->SwBuf.b_flags & Buf::B_BUSY )
	{
		this->SwBuf.b_flags |= Buf::B_WANTED;
		u.u_procp->Sleep((unsigned long)&SwBuf, ProcessManager::PSWP);
	}

	this->SwBuf.b_flags = Buf::B_BUSY | flag;
	this->SwBuf.b_dev = DeviceManager::ROOTDEV;
	this->SwBuf.b_wcount = count;
	this->SwBuf.b_blkno = blkno;
	/* b_addrָҪ䲿ֵڴ׵ַ */
	this->SwBuf.b_addr = (unsigned char *)addr;
	this->m_DeviceManager->GetBlockDevice(Utility::GetMajor(this->SwBuf.b_dev)).Strategy(&this->SwBuf);

	/* жϽB_DONE־ļ */
	X86Assembly::CLI();
	/* Sleep()ͬͬI/OIOWait()Ч */
	while ( (this->SwBuf.b_flags & Buf::B_DONE) == 0 )
	{
		u.u_procp->Sleep((unsigned long)&SwBuf, ProcessManager::PSWP);
	}

	/* Wakeup()ͬBrelse()Ч */
	if ( this->SwBuf.b_flags & Buf::B_WANTED )
	{
		Kernel::Instance().GetProcessManager().WakeUpAll((unsigned long)&SwBuf);
	}
	X86Assembly::STI();
	this->SwBuf.b_flags &= ~(Buf::B_BUSY | Buf::B_WANTED);

	if ( this->SwBuf.b_flags & Buf::B_ERROR )
	{
		return false;
	}
	return true;
}

void BufferManager::GetError(Buf* bp)
{
	User& u = Kernel::Instance().GetUser();

	if (bp->b_flags & Buf::B_ERROR)
	{
		u.u_error = User::EIO;
	}
	return;
}

void BufferManager::NotAvail(Buf *bp)
{
	X86Assembly::CLI();		/* spl6();  UNIX V6 */
	/* ɶȡ */
	bp->av_back->av_forw = bp->av_forw;
	bp->av_forw->av_back = bp->av_back;
	/* B_BUSY־ */
	bp->b_flags |= Buf::B_BUSY;
	X86Assembly::STI();
	return;
}

Buf* BufferManager::InCore(short adev, int blkno)
{
	Buf* bp;
	Devtab* dp;
	short major = Utility::GetMajor(adev);

	dp = this->m_DeviceManager->GetBlockDevice(major).d_tab;
	for(bp = dp->b_forw; bp != (Buf *)dp; bp = bp->b_forw)
	{
		if(bp->b_blkno == blkno && bp->b_dev == adev)
			return bp;
	}
	return NULL;
}

Buf& BufferManager::GetSwapBuf()
{
	return this->SwBuf;
}

Buf& BufferManager::GetBFreeList()
{
	return this->bFreeList;
}

