#include "FileManager.h"
#include "Kernel.h"
#include "Utility.h"
#include "TimeInterrupt.h"

#include "libyrosstd/string.h"

/*==========================class FileManager===============================*/
FileManager::FileManager()
{
	//nothing to do here
}

FileManager::~FileManager()
{
	//nothing to do here
}

void FileManager::Initialize()
{
	this->m_FileSystem = &Kernel::Instance().GetFileSystem();

	this->m_InodeTable = &g_InodeTable;
	this->m_OpenFileTable = &g_OpenFileTable;

	this->m_InodeTable->Initialize();
}

/*
 * ܣļ
 * Чļṹڴiڵ㿪 i_count Ϊi_count ++
 * */
void FileManager::Open()
{
	Inode* pInode;
	User& u = Kernel::Instance().GetUser();

	pInode = this->NameI(NextChar, FileManager::OPEN);	/* 0 = Open, not create */
	/* ûҵӦInode */
	if ( NULL == pInode )
	{
		return;
	}
	this->Open1(pInode, u.u_arg[1], 0);
}

/*
 * ܣһµļ
 * Чļṹڴiڵ㿪 i_count ΪӦ 1
 * */
void FileManager::Creat()
{
	Inode* pInode;
	User& u = Kernel::Instance().GetUser();
	unsigned int newACCMode = u.u_arg[1] & (Inode::IRWXU|Inode::IRWXG|Inode::IRWXO);

	/* Ŀ¼ģʽΪ1ʾĿ¼д */
	pInode = this->NameI(NextChar, FileManager::CREATE);
	/* ûҵӦInodeNameI */
	if ( NULL == pInode )
	{
		if(u.u_error)
			return;
		/* Inode */
		pInode = this->MakNode( newACCMode & (~Inode::ISVTX) );
		/* ʧ */
		if ( NULL == pInode )
		{
			return;
		}

		/* 
		 * ϣֲڣʹòtrf = 2open1()
		 * ҪȨ޼飬ΪոսļȨ޺ʹmode
		 * ʾȨһġ
		 */
		this->Open1(pInode, File::FWRITE, 2);
	}
	else
	{
		/* NameI()ѾҪļոļ㷨ITrunc()UIDûиı
		 * ԭUNIXļȥ½ļһȻļߺȨʽû䡣
		 * Ҳ˵creatָRWXЧ
		 * ΪǲģӦøı䡣
		 * ڵʵ֣creatָRWXЧ */
		this->Open1(pInode, File::FWRITE, 1);
		pInode->i_mode |= newACCMode;
	}
}

/* 
* trf == 0open
* trf == 1creatãcreatļʱͬļļ
* trf == 2creatãcreatļʱδͬļļļʱһ
* modeļģʽʾļ дǶд
*/
void FileManager::Open1(Inode* pInode, int mode, int trf)
{
	User& u = Kernel::Instance().GetUser();

	/* 
	 * ϣļѴڵ£trf == 0trf == 1Ȩ޼
	 * ϣֲڣtrf == 2ҪȨ޼飬Ϊս
	 * ļȨ޺ʹĲmodeʾȨһġ
	 */
	if (trf != 2)
	{
		if ( mode & File::FREAD )
		{
			/* Ȩ */
			this->Access(pInode, Inode::IREAD);
		}
		if ( mode & File::FWRITE )
		{
			/* дȨ */
			this->Access(pInode, Inode::IWRITE);
			/* ϵͳȥдĿ¼ļǲ */
			if ( (pInode->i_mode & Inode::IFMT) == Inode::IFDIR )
			{
				u.u_error = User::EISDIR;
			}
		}
	}

	if ( u.u_error )
	{
		this->m_InodeTable->IPut(pInode);
		return;
	}

	/* creatļʱͬļļͷŸļռݵ̿ */
	if ( 1 == trf )
	{
		pInode->ITrunc();
	}

	/* inode! 
	 * Ŀ¼漰Ĵ̶дڼ̻˯
	 * ˣ̱漰iڵ㡣NameIִеIGet
	 * ˣпܻлĲԽiڵ㡣
	 */
	pInode->Prele();

	/* ļƿFileṹ */
	File* pFile = this->m_OpenFileTable->FAlloc();
	if ( NULL == pFile )
	{
		this->m_InodeTable->IPut(pInode);
		return;
	}
	/* ôļʽFileṹڴInodeĹϵ */
	pFile->f_flag = mode & (File::FREAD | File::FWRITE);
	pFile->f_inode = pInode;

	/* 豸򿪺 */
	pInode->OpenI(mode & File::FWRITE);

	/* Ϊ򿪻ߴļĸԴѳɹ䣬 */
	if ( u.u_error == 0 )
	{
		return;
	}
	else	/* ͷԴ */
	{
		/* ͷŴļ */
		int fd = u.u_ar0[User::EAX];
		if(fd != -1)
		{
			u.u_ofiles.SetF(fd, NULL);
			/* ݼFileṹInodeü ,Fileṹû f_countΪ0ͷFileṹ*/
			pFile->f_count--;
		}
		this->m_InodeTable->IPut(pInode);
	}
}

void FileManager::Close()
{
	User& u = Kernel::Instance().GetUser();
	int fd = u.u_arg[0];

	/* ȡļƿFileṹ */
	File* pFile = u.u_ofiles.GetF(fd);
	if ( NULL == pFile )
	{
		return;
	}

	/* ͷŴļfdݼFileṹü */
	u.u_ofiles.SetF(fd, NULL);
	this->m_OpenFileTable->CloseF(pFile);
}

void FileManager::Seek()
{
	File* pFile;
	User& u = Kernel::Instance().GetUser();
	int fd = u.u_arg[0];

	pFile = u.u_ofiles.GetF(fd);
	if ( NULL == pFile )
	{
		return;  /* FILEڣGetF */
	}

	/* ܵļseek */
	if ( pFile->f_flag & File::FPIPE )
	{
		u.u_error = User::ESPIPE;
		return;
	}

	int offset = u.u_arg[1];

	/* u.u_arg[2]3 ~ 5֮䣬ôȵλֽڱΪ512ֽ */
	if ( u.u_arg[2] > 2 )
	{
		offset = offset << 9;
		u.u_arg[2] -= 3;
	}

	switch ( u.u_arg[2] )
	{
		/* дλΪoffset */
		case 0:
			pFile->f_offset = offset;
			break;
		/* дλüoffset(ɸ) */
		case 1:
			pFile->f_offset += offset;
			break;
		/* дλõΪļȼoffset */
		case 2:
			pFile->f_offset = pFile->f_inode->i_size + offset;
			break;
	}
}

void FileManager::Dup()
{
	File* pFile;
	User& u = Kernel::Instance().GetUser();
	int fd = u.u_arg[0];

	pFile = u.u_ofiles.GetF(fd);
	if ( NULL == pFile )
	{
		return;
	}

	int newFd = u.u_ofiles.AllocFreeSlot();
	if ( newFd < 0 )
	{
		return;
	}
	/* ˷newFdɹ */
	u.u_ofiles.SetF(newFd, pFile);
	pFile->f_count++;
}

void FileManager::FStat()
{
	File* pFile;
	User& u = Kernel::Instance().GetUser();
	int fd = u.u_arg[0];

	pFile = u.u_ofiles.GetF(fd);
	if ( NULL == pFile )
	{
		return;
	}

	/* u.u_arg[1] = pStatBuf */
	this->Stat1(pFile->f_inode, u.u_arg[1]);
}

void FileManager::Stat()
{
	Inode* pInode;
	User& u = Kernel::Instance().GetUser();

	pInode = this->NameI(FileManager::NextChar, FileManager::OPEN);
	if ( NULL == pInode )
	{
		return;
	}
	this->Stat1(pInode, u.u_arg[1]);
	this->m_InodeTable->IPut(pInode);
}

void FileManager::Stat1(Inode* pInode, unsigned long statBuf)
{
	Buf* pBuf;
	BufferManager& bufMgr = Kernel::Instance().GetBufferManager();

	pInode->IUpdate(Time::time);
	pBuf = bufMgr.Bread(pInode->i_dev, FileSystem::INODE_ZONE_START_SECTOR + pInode->i_number / FileSystem::INODE_NUMBER_PER_SECTOR );

	/* pָ򻺴бΪinumberInodeƫλ */
	unsigned char* p = pBuf->b_addr + (pInode->i_number % FileSystem::INODE_NUMBER_PER_SECTOR) * sizeof(DiskInode);
	Utility::DWordCopy( (int *)p, (int *)statBuf, sizeof(DiskInode)/sizeof(int) );

	bufMgr.Brelse(pBuf);
}

void FileManager::Read()
{
	/* ֱӵRdwr() */
	this->Rdwr(File::FREAD);
}

void FileManager::Write()
{
	/* ֱӵRdwr() */
	this->Rdwr(File::FWRITE);
}

void FileManager::Rdwr( enum File::FileFlags mode )
{
	File* pFile;
	User& u = Kernel::Instance().GetUser();

	/* Read()/Write()ϵͳòfdȡļƿṹ */
	pFile = u.u_ofiles.GetF(u.u_arg[0]);	/* fd */
	if ( NULL == pFile )
	{
		/* ڸôļGetFѾù룬ﲻҪ */
		/*	u.u_error = User::EBADF;	*/
		return;
	}


	/* дģʽȷ */
	if ( (pFile->f_flag & mode) == 0 )
	{
		u.u_error = User::EACCES;
		return;
	}

	u.u_IOParam.m_Base = (unsigned char *)u.u_arg[1];	/* Ŀ껺ַ */
	u.u_IOParam.m_Count = u.u_arg[2];		/* Ҫ/дֽ */
	u.u_segflg = 0;		/* User Space I/OҪݶλûջ */

	/* ܵд */
	if(pFile->f_flag & File::FPIPE)
	{
		if ( File::FREAD == mode )
		{
			this->ReadP(pFile);
		}
		else
		{
			this->WriteP(pFile);
		}
	}
	else
	/* ͨļд дļļʵʩʣȣÿϵͳá
	ΪInodeҪNFlock()NFrele()
	ⲻV6ơreadwriteϵͳöڴiڵΪ˸ʵʩIOĽṩһµļͼ*/
	{
		pFile->f_inode->NFlock();
		/* ļʼλ */
		u.u_IOParam.m_Offset = pFile->f_offset;
		if ( File::FREAD == mode )
		{
			pFile->f_inode->ReadI();
		}
		else
		{
			pFile->f_inode->WriteI();
		}

		/* ݶдƶļдƫָ */
		pFile->f_offset += (u.u_arg[2] - u.u_IOParam.m_Count);
		pFile->f_inode->NFrele();
	}

	/* ʵʶдֽ޸Ĵϵͳ÷ֵĺջԪ */
	u.u_ar0[User::EAX] = u.u_arg[2] - u.u_IOParam.m_Count;
}

void FileManager::Pipe()
{
	Inode* pInode;
	File* pFileRead;
	File* pFileWrite;
	int fd[2];
	User& u = Kernel::Instance().GetUser();

	/* һInodeڴܵļ */
	pInode = this->m_FileSystem->IAlloc(DeviceManager::ROOTDEV);
	if ( NULL == pInode )
	{
		return;
	}

	/* ܵFileṹ */
	pFileRead = this->m_OpenFileTable->FAlloc();
	if ( NULL == pFileRead )
	{
		this->m_InodeTable->IPut(pInode);
		return;
	}
	/* ܵĴļ */
	fd[0] = u.u_ar0[User::EAX];

	/* дܵFileṹ */
	pFileWrite = this->m_OpenFileTable->FAlloc();
	if ( NULL == pFileWrite )    /*ʧܣܵصдļṹ*/
	{
		pFileRead->f_count = 0;
		u.u_ofiles.SetF(fd[0], NULL);
		this->m_InodeTable->IPut(pInode);
		return;
	}

	/* дܵĴļ */
	fd[1] = u.u_ar0[User::EAX];

	/* Pipe(int* fd)Ĳu.u_arg[0]Уɹ2fdظû̬ */
	int* pFdarr = (int *)u.u_arg[0];
	pFdarr[0] = fd[0];
	pFdarr[1] = fd[1];

	/* öдܵFileṹ ԺreadwriteϵͳҪʶ*/
	pFileRead->f_flag = File::FREAD | File::FPIPE;
	pFileRead->f_inode = pInode;
	pFileWrite->f_flag = File::FWRITE | File::FPIPE;
	pFileWrite->f_inode = pInode;

	pInode->i_count = 2;
	pInode->i_flag = Inode::IACC | Inode::IUPD;
	pInode->i_mode = Inode::IALLOC;
}

void FileManager::ReadP(File *pFile)
{
	Inode* pInode = pFile->f_inode;
	User& u = Kernel::Instance().GetUser();

loop:
	/* Թܵļ֤ ڵV6汾ͨļĶдҲȡַǳصʽ*/
	pInode->Plock();

	/* ܵûݿɶȡ ܵļβʼдi_sizeдָ롣*/
	if ( pFile->f_offset == pInode->i_size )
	{
		if ( pFile->f_offset != 0 )
		{
			/* ܵļƫ͹ܵļСΪ0 */
			pFile->f_offset = 0;
			pInode->i_size = 0;

			/* IWRITE־ʾнڵȴд˹ܵԱ뻽ӦĽ̡*/
			if ( pInode->i_mode & Inode::IWRITE )
			{
				pInode->i_mode &= (~Inode::IWRITE);
				Kernel::Instance().GetProcessManager().WakeUpAll((unsigned long)(pInode + 1));
			}
		}

		pInode->Prele(); /* Ļдܵ޷Թܵʵʩϵͳ */

		/* ܵĶߡдѾһرգ򷵻 */
		if ( pInode->i_count < 2 )
		{
			return;
		}

		/* IREAD־ʾн̵ȴPipe */
		pInode->i_mode |= Inode::IREAD;
		u.u_procp->Sleep((unsigned long)(pInode + 2), ProcessManager::PPIPE);
		goto loop;
	}

	/* ܵпɶȡ */
	u.u_IOParam.m_Offset = pFile->f_offset;
	pInode->ReadI();
	pFile->f_offset = u.u_IOParam.m_Offset;
	pInode->Prele();
}

void FileManager::WriteP(File* pFile)
{
	Inode* pInode = pFile->f_inode;
	User& u = Kernel::Instance().GetUser();

	int count = u.u_IOParam.m_Count;

loop:
	pInode->Plock();

	/* дܵԹܵunlock */
	if ( 0 == count )
	{
		pInode->Prele();
		u.u_IOParam.m_Count = 0;
		return;
	}

	/* ߽ܵѹرնˡźSIGPIPE֪ͨӦó */
	if ( pInode->i_count < 2 )
	{
		pInode->Prele();
		u.u_error = User::EPIPE;
		u.u_procp->PSignal(User::SIGPIPE);
		return;
	}

	/* Ѿܵĵףͬ־˯ߵȴ */
	if ( Inode::PIPSIZ == pInode->i_size )
	{
		pInode->i_mode |= Inode::IWRITE;
		pInode->Prele();
		u.u_procp->Sleep((unsigned long)(pInode + 1), ProcessManager::PPIPE);
		goto loop;
	}

	/* дݾܶдܵ */
	u.u_IOParam.m_Offset = pInode->i_size;
	u.u_IOParam.m_Count = Utility::Min(count, Inode::PIPSIZ - u.u_IOParam.m_Offset);
	count -= u.u_IOParam.m_Count;
	pInode->WriteI();
	pInode->Prele();

	/* Ѷܵ */
	if ( pInode->i_mode & Inode::IREAD )
	{
		pInode->i_mode &= (~Inode::IREAD);
		Kernel::Instance().GetProcessManager().WakeUpAll((unsigned long)(pInode + 2));
	}
	goto loop;

}

/* NULLʾĿ¼ʧܣǸָ룬ָļڴiڵ ڴiڵ  */
Inode* FileManager::NameI( char (*func)(), enum DirectorySearchMode mode )
{
	Inode* pInode;
	Buf* pBuf;
	char curchar;
	char* pChar;
	int freeEntryOffset;	/* ԴļģʽĿ¼ʱ¼Ŀ¼ƫ */
	User& u = Kernel::Instance().GetUser();
	BufferManager& bufMgr = Kernel::Instance().GetBufferManager();

	/* 
	 * ·'/'ͷģӸĿ¼ʼ
	 * ӽ̵ǰĿ¼ʼ
	 */
	pInode = u.u_cdir;
	if ( '/' == (curchar = (*func)()) )
	{
		pInode = this->rootDirInode;
	}

	/* InodeǷڱʹãԼ֤Ŀ¼иInodeͷ */
	this->m_InodeTable->IGet(pInode->i_dev, pInode->i_number);

	/* ////a//b · ·ȼ/a/b */
	while ( '/' == curchar )
	{
		curchar = (*func)();
	}
	/* ͼĺɾǰĿ¼ļ */
	if ( '\0' == curchar && mode != FileManager::OPEN )
	{
		u.u_error = User::ENOENT;
		goto out;
	}

	/* ѭÿδpathnameһ· */
	while (true)
	{
		/* ͷŵǰĿ¼ļInode˳ */
		if ( u.u_error != User::NOERROR )
		{
			break;	/* goto out; */
		}

		/* ·ϣӦInodeָ롣Ŀ¼ɹء */
		if ( '\0' == curchar )
		{
			return pInode;
		}

		/* ҪĲĿ¼ļͷInodeԴ˳ */
		if ( (pInode->i_mode & Inode::IFMT) != Inode::IFDIR )
		{
			u.u_error = User::ENOTDIR;
			break;	/* goto out; */
		}

		/* Ŀ¼Ȩ޼,IEXECĿ¼ļбʾȨ */
		if ( this->Access(pInode, Inode::IEXEC) )
		{
			u.u_error = User::EACCES;
			break;	/* ߱Ŀ¼Ȩޣgoto out; */
		}

		/* 
		 * Pathnameеǰ׼ƥ·u.u_dbuf[]У
		 * ںĿ¼бȽϡ
		 */
		pChar = &(u.u_dbuf[0]);
		while ( '/' != curchar && '\0' != curchar && u.u_error == User::NOERROR )
		{
			if ( pChar < &(u.u_dbuf[DirectoryEntry::DIRSIZ]) )
			{
				*pChar = curchar;
				pChar++;
			}
			curchar = (*func)();
		}
		/* u_dbufʣĲΪ'\0' */
		while ( pChar < &(u.u_dbuf[DirectoryEntry::DIRSIZ]) )
		{
			*pChar = '\0';
			pChar++;
		}

		/* ////a//b · ·ȼ/a/b */
		while ( '/' == curchar )
		{
			curchar = (*func)();
		}

		if ( u.u_error != User::NOERROR )
		{
			break; /* goto out; */
		}

		/* ڲѭֶu.u_dbuf[]е·ѰƥĿ¼ */
		u.u_IOParam.m_Offset = 0;
		/* ΪĿ¼ հ׵Ŀ¼*/
		u.u_IOParam.m_Count = pInode->i_size / (DirectoryEntry::DIRSIZ + 4);
		freeEntryOffset = 0;
		pBuf = NULL;

		while (true)
		{
			/* Ŀ¼Ѿ */
			if ( 0 == u.u_IOParam.m_Count )
			{
				if ( NULL != pBuf )
				{
					bufMgr.Brelse(pBuf);
				}
				/* Ǵļ */
				if ( FileManager::CREATE == mode && curchar == '\0' )
				{
					/* жϸĿ¼Ƿд */
					if ( this->Access(pInode, Inode::IWRITE) )
					{
						u.u_error = User::EACCES;
						goto out;	/* Failed */
					}

					/* Ŀ¼Inodeָ뱣ԺдĿ¼WriteDir()õ */
					u.u_pdir = pInode;

					if ( freeEntryOffset )	/* ˱˿Ŀ¼λĿ¼ļеƫ */
					{
						/* Ŀ¼ƫuУдĿ¼WriteDir()õ */
						u.u_IOParam.m_Offset = freeEntryOffset - (DirectoryEntry::DIRSIZ + 4);
					}
					else  /*⣺Ϊif֧ûIUPD־  Ϊļĳûбѽ*/
					{
						pInode->i_flag |= Inode::IUPD;
					}
					/* ҵдĿĿ¼λãNameI() */
					return NULL;
				}
				
				/* Ŀ¼϶ûҵƥͷInodeԴƳ */
				u.u_error = User::ENOENT;
				goto out;
			}

			/* ѶĿ¼ļĵǰ̿飬ҪһĿ¼̿ */
			if ( 0 == u.u_IOParam.m_Offset % Inode::BLOCK_SIZE )
			{
				if ( NULL != pBuf )
				{
					bufMgr.Brelse(pBuf);
				}
				/* Ҫ̿ */
				int phyBlkno = pInode->Bmap(u.u_IOParam.m_Offset / Inode::BLOCK_SIZE );
				pBuf = bufMgr.Bread(pInode->i_dev, phyBlkno );
			}

			/* ûж굱ǰĿ¼̿飬ȡһĿ¼u.u_dent */
			int* src = (int *)(pBuf->b_addr + (u.u_IOParam.m_Offset % Inode::BLOCK_SIZE));
			Utility::DWordCopy( src, (int *)&u.u_dent, sizeof(DirectoryEntry)/sizeof(int) );

			u.u_IOParam.m_Offset += (DirectoryEntry::DIRSIZ + 4);
			u.u_IOParam.m_Count--;

			/* ǿĿ¼¼λĿ¼ļƫ */
			if ( 0 == u.u_dent.m_ino )
			{
				if ( 0 == freeEntryOffset )
				{
					freeEntryOffset = u.u_IOParam.m_Offset;
				}
				/* Ŀ¼ȽһĿ¼ */
				continue;
			}

			int i;
			for ( i = 0; i < DirectoryEntry::DIRSIZ; i++ )
			{
				if ( u.u_dbuf[i] != u.u_dent.m_name[i] )
				{
					break;	/* ƥĳһַforѭ */
				}
			}

			if( i < DirectoryEntry::DIRSIZ )
			{
				/* ҪĿ¼ƥһĿ¼ */
				continue;
			}
			else
			{
				/* Ŀ¼ƥɹصWhile(true)ѭ */
				break;
			}
		}

		/* 
		 * ڲĿ¼ƥѭ˴˵pathname
		 * ǰ·ƥɹˣƥpathnameһ·
		 * ֱ'\0'
		 */
		if ( NULL != pBuf )
		{
			bufMgr.Brelse(pBuf);
		}

		/* ɾ򷵻ظĿ¼InodeҪɾļInodeu.u_dent.m_ino */
		if ( FileManager::DELETE == mode && '\0' == curchar )
		{
			/* ԸĿ¼ûдȨ */
			if ( this->Access(pInode, Inode::IWRITE) )
			{
				u.u_error = User::EACCES;
				break;	/* goto out; */
			}
			return pInode;
		}

		/* 
		 * ƥĿ¼ɹͷŵǰĿ¼Inodeƥɹ
		 * Ŀ¼m_inoֶλȡӦһĿ¼ļInode
		 */
		short dev = pInode->i_dev;
		this->m_InodeTable->IPut(pInode);
		pInode = this->m_InodeTable->IGet(dev, u.u_dent.m_ino);
		/* صWhile(true)ѭƥPathnameһ· */

		if ( NULL == pInode )	/* ȡʧ */
		{
			return NULL;
		}
	}
out:
	this->m_InodeTable->IPut(pInode);
	return NULL;
}

char FileManager::NextChar()
{
	User& u = Kernel::Instance().GetUser();
	
	/* u.u_dirpָpathnameеַ */
	return *u.u_dirp++;
}

/* creatá
 * Ϊ´ļдµiڵµĿ¼
 * صpInodeڴiڵ㣬еi_count 1
 *
 * ڳ WriteDirԼĿ¼дĿ¼޸ĸĿ¼ļiڵ дش̡
 *
 */
Inode* FileManager::MakNode( unsigned int mode )
{
	Inode* pInode;
	User& u = Kernel::Instance().GetUser();

	/* һDiskInodeȫ */
	pInode = this->m_FileSystem->IAlloc(u.u_pdir->i_dev);
	if( NULL ==	pInode )
	{
		return NULL;
	}

	pInode->i_flag |= (Inode::IACC | Inode::IUPD);
	pInode->i_mode = mode | Inode::IALLOC;
	pInode->i_nlink = 1;
	pInode->i_uid = u.u_uid;
	pInode->i_gid = u.u_gid;
	/* Ŀ¼дu.u_dentдĿ¼ļ */
	this->WriteDir(pInode);
	return pInode;
}

void FileManager::WriteDir( Inode* pInode )
{
	User& u = Kernel::Instance().GetUser();

	/* Ŀ¼InodeŲ */
	u.u_dent.m_ino = pInode->i_number;

	/* Ŀ¼pathname */
	for ( int i = 0; i < DirectoryEntry::DIRSIZ; i++ )
	{
		u.u_dent.m_name[i] = u.u_dbuf[i];
	}

	u.u_IOParam.m_Count = DirectoryEntry::DIRSIZ + 4;
	u.u_IOParam.m_Base = (unsigned char *)&u.u_dent;
	u.u_segflg = 1;

	/* Ŀ¼д븸Ŀ¼ļ */
	u.u_pdir->WriteI();
	this->m_InodeTable->IPut(u.u_pdir);
}

void FileManager::SetCurDir(char* pathname)
{
	User& u = Kernel::Instance().GetUser();
	
	/* ·ǴӸĿ¼'/'ʼu.u_curdirϵǰ· */
	if ( pathname[0] != '/' )
	{
		int length = strlen(u.u_curdir);
		if ( u.u_curdir[length - 1] != '/' )
		{
			u.u_curdir[length] = '/';
			length++;
		}
		strcpy(u.u_curdir + length, pathname);
	}
	else	/* ǴӸĿ¼'/'ʼȡԭйĿ¼ */
	{
		strcpy(u.u_curdir, pathname);
	}
}

/*
 * ֵ0ʾӵдļȨޣ1ʾûķȨޡļδܴ򿪵ԭ¼u.u_errorС
 */
int FileManager::Access( Inode* pInode, unsigned int mode )
{
	User& u = Kernel::Instance().GetUser();

	/* дȨޣļϵͳǷֻ */
	if ( Inode::IWRITE == mode )
	{
		if( this->m_FileSystem->GetFS(pInode->i_dev)->s_ronly != 0 )
		{
			u.u_error = User::EROFS;
			return 1;
		}
	}
	/* 
	 * ڳûдκļ
	 * Ҫִĳļʱi_modeпִб־
	 */
	if ( u.u_uid == 0 )
	{
		if ( Inode::IEXEC == mode && ( pInode->i_mode & (Inode::IEXEC | (Inode::IEXEC >> 3) | (Inode::IEXEC >> 6)) ) == 0 )
		{
			u.u_error = User::EACCES;
			return 1;
		}
		return 0;	/* Permission Check Succeed! */
	}
	if ( u.u_uid != pInode->i_uid )
	{
		mode = mode >> 3;
		if ( u.u_gid != pInode->i_gid )
		{
			mode = mode >> 3;
		}
	}
	if ( (pInode->i_mode & mode) != 0 )
	{
		return 0;
	}

	u.u_error = User::EACCES;
	return 1;
}

Inode* FileManager::Owner()
{
	Inode* pInode;
	User& u = Kernel::Instance().GetUser();

	if ( (pInode = this->NameI(NextChar, FileManager::OPEN)) == NULL )
	{
		return NULL;
	}

	if ( u.u_uid == pInode->i_uid || u.SUser() )
	{
		return pInode;
	}

	this->m_InodeTable->IPut(pInode);
	return NULL;
}

void FileManager::ChMod()
{
	Inode* pInode;
	User& u = Kernel::Instance().GetUser();
	unsigned int mode = u.u_arg[1];

	if ( (pInode = this->Owner()) == NULL )
	{
		return;
	}
	/* clear i_modeֶеISGID, ISUID, ISTVXԼrwxrwxrwx12 */
	pInode->i_mode &= (~0xFFF);
	/* ϵͳõĲi_modeֶ */
	pInode->i_mode |= (mode & 0xFFF);
	pInode->i_flag |= Inode::IUPD;

	this->m_InodeTable->IPut(pInode);
	return;
}

void FileManager::ChOwn()
{
	Inode* pInode;
	User& u = Kernel::Instance().GetUser();
	short uid = u.u_arg[1];
	short gid = u.u_arg[2];

	/* ǳû߲ļ򷵻 */
	if ( !u.SUser() || (pInode = this->Owner()) == NULL )
	{
		return;
	}
	pInode->i_uid = uid;
	pInode->i_gid = gid;
	pInode->i_flag |= Inode::IUPD;

	this->m_InodeTable->IPut(pInode);
}

void FileManager::ChDir()
{
	Inode* pInode;
	User& u = Kernel::Instance().GetUser();

	pInode = this->NameI(FileManager::NextChar, FileManager::OPEN);
	if ( NULL == pInode )
	{
		return;
	}
	/* ļĿ¼ļ */
	if ( (pInode->i_mode & Inode::IFMT) != Inode::IFDIR )
	{
		u.u_error = User::ENOTDIR;
		this->m_InodeTable->IPut(pInode);
		return;
	}
	if ( this->Access(pInode, Inode::IEXEC) )
	{
		this->m_InodeTable->IPut(pInode);
		return;
	}
	this->m_InodeTable->IPut(u.u_cdir);
	u.u_cdir = pInode;
	pInode->Prele();

	this->SetCurDir((char *)u.u_arg[0] /* pathname */);
}

void FileManager::Link()
{
	Inode* pInode;
	Inode* pNewInode;
	User& u = Kernel::Instance().GetUser();

	pInode = this->NameI(FileManager::NextChar, FileManager::OPEN);
	/* ļʧ */
	if ( NULL == pInode )
	{
		return;
	}
	/* ӵѾ */
	if ( pInode->i_nlink >= 255 )
	{
		u.u_error = User::EMLINK;
		/* ͷԴ˳ */
		this->m_InodeTable->IPut(pInode);
		return;
	}
	/* Ŀ¼ļֻɳû */
	if ( (pInode->i_mode & Inode::IFMT) == Inode::IFDIR && !u.SUser() )
	{
		/* ͷԴ˳ */
		this->m_InodeTable->IPut(pInode);
		return;
	}

	/* ִļInode,Աļʱ */
	pInode->i_flag &= (~Inode::ILOCK);
	/* ָҪ·newPathname */
	u.u_dirp = (char *)u.u_arg[1];
	pNewInode = this->NameI(FileManager::NextChar, FileManager::CREATE);
	/* ļѴ */
	if ( NULL != pNewInode )
	{
		u.u_error = User::EEXIST;
		this->m_InodeTable->IPut(pNewInode);
	}
	if ( User::NOERROR != u.u_error )
	{
		/* ͷԴ˳ */
		this->m_InodeTable->IPut(pInode);
		return;
	}
	/* Ŀ¼ļǷͬһ豸 */
	if ( u.u_pdir->i_dev != pInode->i_dev )
	{
		this->m_InodeTable->IPut(u.u_pdir);
		u.u_error = User::EXDEV;
		/* ͷԴ˳ */
		this->m_InodeTable->IPut(pInode);
		return;
	}

	this->WriteDir(pInode);
	pInode->i_nlink++;
	pInode->i_flag |= Inode::IUPD;
	this->m_InodeTable->IPut(pInode);
}

void FileManager::UnLink()
{
	Inode* pInode;
	Inode* pDeleteInode;
	User& u = Kernel::Instance().GetUser();

	pDeleteInode = this->NameI(FileManager::NextChar, FileManager::DELETE);
	if ( NULL == pDeleteInode )
	{
		return;
	}
	pDeleteInode->Prele();

	pInode = this->m_InodeTable->IGet(pDeleteInode->i_dev, u.u_dent.m_ino);
	if ( NULL == pInode )
	{
		Utility::Panic("unlink -- iget");
	}
	/* ֻrootunlinkĿ¼ļ */
	if ( (pInode->i_mode & Inode::IFMT) == Inode::IFDIR && !u.SUser() )
	{
		this->m_InodeTable->IPut(pDeleteInode);
		this->m_InodeTable->IPut(pInode);
		return;
	}
	/* дĿ¼ */
	u.u_IOParam.m_Offset -= (DirectoryEntry::DIRSIZ + 4);
	u.u_IOParam.m_Base = (unsigned char *)&u.u_dent;
	u.u_IOParam.m_Count = DirectoryEntry::DIRSIZ + 4;
	
	u.u_dent.m_ino = 0;
	pDeleteInode->WriteI();

	/* ޸inode */
	pInode->i_nlink--;
	pInode->i_flag |= Inode::IUPD;

	this->m_InodeTable->IPut(pDeleteInode);
	this->m_InodeTable->IPut(pInode);
}

void FileManager::MkNod()
{
	Inode* pInode;
	User& u = Kernel::Instance().GetUser();

	/* uidǷrootϵͳֻuid==rootʱſɱ */
	if ( u.SUser() )
	{
		pInode = this->NameI(FileManager::NextChar, FileManager::CREATE);
		/* ҪļѾ,ﲢȥǴļ */
		if ( pInode != NULL )
		{
			u.u_error = User::EEXIST;
			this->m_InodeTable->IPut(pInode);
			return;
		}
	}
	else
	{
		/* rootûִmknod()ϵͳ÷User::EPERM */
		u.u_error = User::EPERM;
		return;
	}
	/* ûͨSUser()ļ */
	if ( User::NOERROR != u.u_error )
	{
		return;	/* ûҪͷŵԴֱ˳ */
	}
	pInode = this->MakNode(u.u_arg[1]);
	if ( NULL == pInode )
	{
		return;
	}
	/* 豸ļ */
	if ( (pInode->i_mode & (Inode::IFBLK | Inode::IFCHR)) != 0 )
	{
		pInode->i_addr[0] = u.u_arg[2];
	}
	this->m_InodeTable->IPut(pInode);
}
/*==========================class DirectoryEntry===============================*/
DirectoryEntry::DirectoryEntry()
{
	this->m_ino = 0;
	this->m_name[0] = '\0';
}

DirectoryEntry::~DirectoryEntry()
{
	//nothing to do here
}

