#include "OpenFileManager.h"
#include "Kernel.h"
#include "TimeInterrupt.h"
#include "Video.h"

/*==============================class OpenFileTable===================================*/
/* ϵͳȫִļʵĶ */
OpenFileTable g_OpenFileTable;

OpenFileTable::OpenFileTable()
{
	//nothing to do here
}

OpenFileTable::~OpenFileTable()
{
	//nothing to do here
}

/*ã̴ļҵĿ  ֮ ±  д u_ar0[EAX]*/
File* OpenFileTable::FAlloc()
{
	int fd;
	User& u = Kernel::Instance().GetUser();

	/* ڽ̴ļлȡһ */
	fd = u.u_ofiles.AllocFreeSlot();

	if(fd < 0)	/* Ѱҿʧ */
	{
		return NULL;
	}

	for(int i = 0; i < OpenFileTable::NFILE; i++)
	{
		/* f_count==0ʾ */
		if(this->m_File[i].f_count == 0)
		{
			/* FileṹĹϵ */
			u.u_ofiles.SetF(fd, &this->m_File[i]);
			/* Ӷfileṹü */
			this->m_File[i].f_count++;
			/* ļдλ */
			this->m_File[i].f_offset = 0;
			return (&this->m_File[i]);
		}
	}

	Diagnose::Write("No Free File Struct\n");
	u.u_error = User::ENFILE;
	return NULL;
}

void OpenFileTable::CloseF(File *pFile)
{
	Inode* pNode;
	ProcessManager& procMgr = Kernel::Instance().GetProcessManager();

	/* ܵ */
	if(pFile->f_flag & File::FPIPE)
	{
		pNode = pFile->f_inode;
		pNode->i_mode &= ~(Inode::IREAD | Inode::IWRITE);
		procMgr.WakeUpAll((unsigned long)(pNode + 1));
		procMgr.WakeUpAll((unsigned long)(pNode + 2));
	}

	if(pFile->f_count <= 1)
	{
		/* 
		 * ǰһøļḶ̌
		 * 豸ַ豸ļӦĹرպ
		 */
		pFile->f_inode->CloseI(pFile->f_flag & File::FWRITE);
		g_InodeTable.IPut(pFile->f_inode);
	}

	/* õǰFileĽ1 */
	pFile->f_count--;
}

/*==============================class InodeTable===================================*/
/*  ڴInodeʵ */
InodeTable g_InodeTable;

InodeTable::InodeTable()
{
	//nothing to do here
}

InodeTable::~InodeTable()
{
	//nothing to do here
}

void InodeTable::Initialize()
{
	/* ȡg_FileSystem */
	this->m_FileSystem = &Kernel::Instance().GetFileSystem();
}

Inode* InodeTable::IGet(short dev, int inumber)
{
	Inode* pInode;
	User& u = Kernel::Instance().GetUser();

	while(true)
	{
		/* ָ豸devбΪinumberInodeǷڴ濽 */
		int index = this->IsLoaded(dev, inumber);
		if(index >= 0)	/* ҵڴ濽 */
		{
			pInode = &(this->m_Inode[index]);
			/* ڴInode */
			if( pInode->i_flag & Inode::ILOCK )
			{
				/* IWANT־Ȼ˯ */
				pInode->i_flag |= Inode::IWANT;
				
				u.u_procp->Sleep((unsigned long)&pInode, ProcessManager::PINOD);
				
				/* صwhileѭҪΪڴInodeѾʧЧ */
				continue;
			}

			/* ڴInodeļϵͳҸInodeӦMountװ */
			if( pInode->i_flag & Inode::IMOUNT )
			{
				Mount* pMount = this->m_FileSystem->GetMount(pInode);
				if(NULL == pMount)
				{
					/* ûҵ */
					Utility::Panic("No Mount Tab...");
				}
				else
				{
					/* Ϊļϵͳ豸šĿ¼Inode */
					dev = pMount->m_dev;
					inumber = FileSystem::ROOTINO;
					/* صwhileѭdevinumberֵ */
					continue;
				}
			}

			/* 
			 * ִеʾڴInodeٻҵӦڴInode
			 * üILOCK־֮
			 */
			pInode->i_count++;
			pInode->i_flag |= Inode::ILOCK;
			return pInode;
		}
		else	/* ûInodeڴ濽һڴInode */
		{
			pInode = this->GetFreeInode();
			/* ڴInodeInodeʧ */
			if(NULL == pInode)
			{
				Diagnose::Write("Inode Table Overflow !\n");
				u.u_error = User::ENFILE;
				return NULL;
			}
			else	/* InodeɹInode·ڴInode */
			{
				/* µ豸šInodeţüڵ */
				pInode->i_dev = dev;
				pInode->i_number = inumber;
				pInode->i_flag = Inode::ILOCK;
				pInode->i_count++;
				pInode->i_lastr = -1;

				BufferManager& bm = Kernel::Instance().GetBufferManager();
				/* Inode뻺 */
				Buf* pBuf = bm.Bread(dev, FileSystem::INODE_ZONE_START_SECTOR + inumber / FileSystem::INODE_NUMBER_PER_SECTOR );

				/* I/O */
				if(pBuf->b_flags & Buf::B_ERROR)
				{
					/* ͷŻ */
					bm.Brelse(pBuf);
					/* ͷռݵڴInode */
					this->IPut(pInode);
					return NULL;
				}

				/* еInodeϢ·ڴInode */
				pInode->ICopy(pBuf, inumber);
				/* ͷŻ */
				bm.Brelse(pBuf);
				return pInode;
			}
		}
	}
	return NULL;	/* GCC likes it! */
}

/* closeļʱIput
 *      ҪĲڴiڵ i_count--Ϊ0ͷڴ iڵ㡢иĶдش
 * ļ;Ŀ¼ļ󶼻Iputڴiڵ㡣·ĵ2·һǸ
 *   Ŀ¼ļдļɾһļдɾĿ¼ô
 *   	뽫Ŀ¼ļӦڴ iڵдش̡
 *   	Ŀ¼ļǷģǱ뽫iڵдش̡
 * */
void InodeTable::IPut(Inode *pNode)
{
	/* ǰΪøڴInodeΨһ̣׼ͷŸڴInode */
	if(pNode->i_count == 1)
	{
		/* 
		 * ΪͷŹпΪ̲ʹøý˯ߣ
		 * ʱпһ̻ԸڴInodeв⽫пܵ´
		 */
		pNode->i_flag |= Inode::ILOCK;

		/* ļѾûĿ¼·ָ */
		if(pNode->i_nlink <= 0)
		{
			/* ͷŸļռݵ̿ */
			pNode->ITrunc();
			pNode->i_mode = 0;
			/* ͷŶӦInode */
			this->m_FileSystem->IFree(pNode->i_dev, pNode->i_number);
		}

		/* InodeϢ */
		pNode->IUpdate(Time::time);

		/* ڴInodeһѵȴ */
		pNode->Prele();
		/* ڴInodeб־λ */
		pNode->i_flag = 0;
		/* ڴinodeеı־֮һһi_count == 0 */
		pNode->i_number = -1;
	}

	/* ڴInodeüѵȴ */
	pNode->i_count--;
	pNode->Prele();
}

void InodeTable::UpdateInodeTable()
{
	for(int i = 0; i < InodeTable::NINODE; i++)
	{
		/* 
		 * InodeûбǰδʹãͬInode
		 * count0count == 0ζŸڴInodeδκδļãͬ
		 */
		if( (this->m_Inode[i].i_flag & Inode::ILOCK) == 0 && this->m_Inode[i].i_count != 0 )
		{
			/* ڴInodeͬInode */
			this->m_Inode[i].i_flag |= Inode::ILOCK;
			this->m_Inode[i].IUpdate(Time::time);

			/* ڴInode */
			this->m_Inode[i].Prele();
		}
	}
}

int InodeTable::IsLoaded(short dev, int inumber)
{
	/* ѰָInodeڴ濽 */
	for(int i = 0; i < InodeTable::NINODE; i++)
	{
		if( this->m_Inode[i].i_dev == dev && this->m_Inode[i].i_number == inumber && this->m_Inode[i].i_count != 0 )
		{
			return i;	
		}
	}
	return -1;
}

Inode* InodeTable::GetFreeInode()
{
	for(int i = 0; i < InodeTable::NINODE; i++)
	{
		/* ڴInodeüΪ㣬Inodeʾ */
		if(this->m_Inode[i].i_count == 0)
		{
			return &(this->m_Inode[i]);
		}
	}
	return NULL;	/* Ѱʧ */
}
