#ifndef CMOSTIME_H
#define CMOSTIME_H

#include "Utility.h"

class CMOSTime
{
public:
	/* static const member variables*/
	static const unsigned short CMOS_ADDR_PORT = 0x70;		/* CMOSַ˿ں0x70ö˿ѡҪȡCMOSֽƫ */	
	static const unsigned short CMOS_DATA_PORT = 0x71;		/* CMOSݶ˿ں0x71ȡָֽƫƵݵĶ˿ */
	
	/* CMOS洢иֽƫĶ ݶΪ!!BCDʽ!!洢Ҫתɶ */
	static const unsigned char RTC_SECONDS = 0x00;			/* ʵʱ(Real Time Clock)ǰֵ */
	static const unsigned char RTC_ALARM_SECONDS = 0x01;	/* ʵʱ(Real Time Clock)ֵNot Used */
	static const unsigned char RTC_MINUTES = 0x02;			/* ʵʱ(Real Time Clock)ǰֵ */
	static const unsigned char RTC_ALARM_MINUTES = 0x03;	/* ʵʱ(Real Time Clock)ֵNot Used */
	static const unsigned char RTC_HOURS = 0x04;			/* ʵʱ(Real Time Clock)ǰСʱֵ */
	static const unsigned char RTC_ALARM_HOURS = 0x05;		/* ʵʱ(Real Time Clock)СʱֵNot Used */
	static const unsigned char RTC_DAY_OF_WEEK = 0x06;		/* ʵʱ(Real Time Clock)Days of Week since Sunday: 1 ~ 7 */
	static const unsigned char RTC_DAY_OF_MONTH = 0x07;		/* ʵʱ(Real Time Clock)Days of Month: 1 ~ 31 */
	static const unsigned char RTC_MONTH = 0x08;			/* ʵʱ(Real Time Clock)ǰ·ֵMonths since January: 0 ~ 11 */
	static const unsigned char RTC_YEAR = 0x09;				/* ʵʱ(Real Time Clock)ǰֵ4λеĺ2λYears since 1900 */
	static const unsigned char RTC_STATUS_REGISTER_A = 0x0A;/* ʵʱ(Real Time Clock)״̬ĴA */
	static const unsigned char RTC_STATUS_REGISTER_B = 0x0B;/* ʵʱ(Real Time Clock)״̬ĴBNot Used */
	static const unsigned char RTC_STATUS_REGISTER_C = 0x0C;/* ʵʱ(Real Time Clock)״̬ĴCNot Used */
	static const unsigned char RTC_STATUS_REGISTER_D = 0x0D;/* ʵʱ(Real Time Clock)״̬ĴDNot Used */
	
	static const unsigned char BASE_MEMORY_LOW = 0x15;			/* ڴ(ֽ) */
	static const unsigned char BASE_MEMORY_HIGH = 0x16;			/* ڴ(ֽ) */
	static const unsigned char EXTENDED_MEMORY_LOW = 0x17;		/* չڴ(ֽ) */
	static const unsigned char EXTENDED_MEMORY_HIGH = 0x18;		/* չڴ(ֽ) */
	static const unsigned char EXTENDED_MEMORY_ABOVE_1MB_LOW = 0x30;	/* 1MBչڴ(ֽ) */
	static const unsigned char EXTENDED_MEMORY_ABOVE_1MB_HIGH = 0x31;	/* 1MBչڴ(ֽ) */

	/* RTC״̬ĴAλ壺 */
	static const unsigned char RTC_UPDATE_IN_PROGRESS = 0x80;	/* Bit(7)1ʾTime update in progressڸCMOSʱ䣬
																ʱɶȡBit(7)0ʾԶȡCMOSʱ */

public:
	/* COMS洢лȡϵͳʱ䣬SystemTimeṹ */
	static void ReadCMOSTime(struct SystemTime* pTime);

	/* ȡָƫλϵCMOS洢 */
	static int ReadCMOSByte(unsigned char CMOSOffset);
};

#endif
