#ifndef DMA_H
#define DMA_H

extern int dmaConfig[64]; // todo
/* 
 * Physical Region Descriptor(PRD) ڴ
 * ڴ֮DMAʽݴʱ
 * Դ(Ŀ)ڴʼַ Ϣݽṹ
 */
class PhysicalRegionDescriptor
{
	/* Members */
private:
	unsigned long m_BaseAddressZeroBit : 1;	/*  ڴ "ʼַ"(עԵַ)ĵ0λλΪ0ζڴ滺2ֽڶ */
	unsigned long m_MemoryRegionPhysicalBaseAddress : 31;	/* ڴ "ʼַ"ĵ[31 : 1]λ */
	unsigned short m_ByteCountZeroBit : 1;			/* DMAֽByte Countĵ0λΪ0 ζÿδֽֽڳ */
	unsigned short m_ByteCount : 15;				/* DMAֽByte Countĵ[15 : 1]λ */
	unsigned short m_Reserved : 15;					/*  */
	unsigned short m_EOT : 1;						/* Bit(31)End of TableλλΪ1ʾǰڴ(PRD)PRDеһ */
	
public:
	void SetBaseAddress(unsigned long phyBaseAddr);
	void SetByteCount(unsigned short bytes);
	void SetEndOfTable(bool EOT /* End of Table */ );
	
}__attribute__((packed));


/* 
 * ڴ(PRD)һPRDԹ
 * ÿһDMAڴɴ˿
 * ڴϲĶͬһDMA䡣
 * 
 * һڴBit(31)Ϊ1ʾPRD TableĽ
 * ÿһDMAʱDMAоƬPRD Tableĵ0ʼ
 * /дÿһPRDڴֱDMAоƬ⵽еnPRD
 * Bit(31)Ϊ1ΪPRD TableDMA䡣
 * 
 * ע: PRD Tableڴǲ
 * ģڴģPRDTable
 * ʹʽʵ
 */
class PRDTable
{
public:
	/* static const */
	static const int NSIZE = 10;		/* PRD TableĿ */

	/* Members */
public:
	/* indexӦڴ(PRD) */
	void SetPhysicalRegionDescriptor(int index, PhysicalRegionDescriptor& prd, bool EOT /* End of Table */);
	
	/* ȡPRD Tableʼַ (עصַԵַ) */
	unsigned long GetPRDTableBaseAddress();
	
private:
	/* 
	 * PRD Tableʼַ4ֽڶ룬DMAоƬڲ
	 * Ĵ(PRDTR)üĴPRD TableBase Address
	 * [31 : 2]λ,Ե[1 : 0]λҪ4ֽڶ롣
	 */
	PhysicalRegionDescriptor m_Descriptors[NSIZE] __attribute__((aligned (4)));
};


/* 
 * DMAװDMAоƬڲĴĶ˿ںţ
 * Ĵ״̬ĴԼ
 * Ĵ(PRDTR)Ķ˿ںš
 * 
 * ͬʱЩĴضλӦĳ
 */
class DMA
{
public:
	/* static member */
	static unsigned short COMMAND_PORT;		/* ĴĶ˿ں */
	static unsigned short STATUS_PORT;		/* ״̬ĴĶ˿ں */
	static unsigned short PRDTR_PORT;		/* PRD TableַĴĶ˿ں */

	/* Ĵ (˿ںţCOMMAND_PORT) λ */
	enum DMAStart	/* ĴBit(0)Start/Stopλ */
	{
		START	=	0x01,		/* Bit(0) = 1һDMA */
		STOP	=	0x00		/* Bit(0) = 0ִֹͣеDMA
								ִǰһDMA֮ҲҪָBit(0)Ϊ0 */
	};

	enum DMAType	/* ĴBit(3), Read/WriteλDMAоƬDMAķ */
	{
		READ	=	0x08,		/* DMA ReadBit(3) = 1ʾӲ̣дڴ */
		WRITE	=	0x00		/* DMA WriteBit(3) = 0ʾдӲ̣ڴ */
	};
	/* Ĵ (˿ںţCOMMAND_PORT) 8ֻBit(0)Bit(3)ΪЧλ */


	/* ״̬Ĵ (˿ںţSTATUS_PORT) λ壺 ֻõ8λеBit(0 - 2) */
	static const unsigned char ACTIVE = 0x01;	/* AcitveλBit(0)DMAִڼӲ1
												DMAɺӲԶ0*/
												
	static const unsigned char ERROR =	0x02;	/* ErrorλBit(1)DMAִйӲλ1
												ָͨдһ1ñλλ0
												ͨд1㣬е֡ ǾЧ*/
												
	static const unsigned char Interrupt = 0x04; /* InterruptλBit(2)DMAɣ
												CPUж(CPUǷж)֮
												ӲΪ1ʾѾж 
												ָͨдһ1ñλλ0*/

public:
	static void Init();			/* ʼDMAоƬȷDMAоƬڲĴռݵI/O˿ں */

	static void Reset();		/* DMAоƬǰһDMAĽ״̬ */
	
	static bool IsError();		/* ǰһDMAִйǷ */

	/* ݲ涨DMA͡PRD TableʼַDMA */
	static void Start(enum DMAType type, unsigned long baseAddress);
};

#endif
