#ifndef FILE_MANAGER_H
#define FILE_MANAGER_H

#include "FileSystem.h"
#include "OpenFileManager.h"
#include "File.h"

/* 
 * ļ(FileManager)
 * װļϵͳĸϵͳں̬´̣
 * ļOpen()Close()Read()Write()ȵ
 * װ˶ļϵͳʵľϸڡ
 */
class FileManager
{
public:
	/* Ŀ¼ģʽNameI() */
	enum DirectorySearchMode
	{
		OPEN = 0,		/* ԴļʽĿ¼ */
		CREATE = 1,		/* ½ļʽĿ¼ */
		DELETE = 2		/* ɾļʽĿ¼ */
	};

	/* Functions */
public:
	/* Constructors */
	FileManager();
	/* Destructors */
	~FileManager();


	/* 
	 * @comment ʼȫֶ
	 */
	void Initialize();

	/* 
	 * @comment Open()ϵͳô
	 */
	void Open();

	/* 
	 * @comment Creat()ϵͳô
	 */
	void Creat();

	/* 
	 * @comment Open()Creat()ϵͳõĹ
	 */
	void Open1(Inode* pInode, int mode, int trf);

	/* 
	 * @comment Close()ϵͳô
	 */
	void Close();

	/* 
	 * @comment Seek()ϵͳô
	 */
	void Seek();

	/* 
	 * @comment Dup()ƽ̴ļ
	 */
	void Dup();

	/* 
	 * @comment FStat()ȡļϢ
	 */
	void FStat();

	/* 
	 * @comment FStat()ȡļϢ
	 */
	void Stat();

	/* FStat()Stat()ϵͳõĹ */
	void Stat1(Inode* pInode, unsigned long statBuf);

	/* 
	 * @comment Read()ϵͳô
	 */
	void Read();

	/* 
	 * @comment Write()ϵͳô
	 */
	void Write();

	/* 
	 * @comment дϵͳùִ
	 */
	void Rdwr(enum File::FileFlags mode);

	/* 
	 * @comment Pipe()ܵϵͳô
	 */
	void Pipe();

	/* 
	 * @comment ܵ
	 */
	void ReadP(File* pFile);

	/* 
	 * @comment ܵд
	 */
	void WriteP(File* pFile);
	
	/* 
	 * @comment Ŀ¼·תΪӦInode
	 * Inode
	 */
	Inode* NameI(char (*func)(), enum DirectorySearchMode mode);

	/* 
	 * @comment ȡ·еһַ
	 */
	static char NextChar();

	/* 
	 * @comment Creat()ϵͳʹãΪļںԴ
	 */
	Inode* MakNode(unsigned int mode);

	/* 
	 * @comment Ŀ¼Ŀ¼ļдһĿ¼
	 */
	void WriteDir(Inode* pInode);

	/*
	 * @comment õǰ·
	 */
	void SetCurDir(char* pathname);

	/* 
	 * @comment ļĿ¼ȨޣΪϵͳõĸ
	 */
	int Access(Inode* pInode, unsigned int mode);

	/* 
	 * @comment ļǷڵǰû
	 */
	Inode* Owner();

	/* ıļģʽ */
	void ChMod();

	/* ıļļuser IDgroup ID */
	void ChOwn();

	/* ı䵱ǰĿ¼ */
	void ChDir();

	/* ļ */
	void Link();

	/* ȡļ */
	void UnLink();

	/* ڽ豸ļϵͳ */
	void MkNod();
	
public:
	/* Ŀ¼ڴInode */
	Inode* rootDirInode;

	/* ȫֶg_FileSystemãöļϵͳ洢Դ */
	FileSystem* m_FileSystem;
	
	/* ȫֶg_InodeTableãöڴInodeĹ */
	InodeTable* m_InodeTable;

	/* ȫֶg_OpenFileTableãöļĹ */
	OpenFileTable* m_OpenFileTable;
};


class DirectoryEntry
{
	/* static members */
public:
	static const int DIRSIZ = 28;	/* Ŀ¼·ֵַ */

	/* Functions */
public:
	/* Constructors */
	DirectoryEntry();
	/* Destructors */
	~DirectoryEntry();

	/* Members */
public:
	int m_ino;		/* Ŀ¼InodeŲ */
	char m_name[DIRSIZ];	/* Ŀ¼· */
};

#endif
