#ifndef FILE_SYSTEM_H
#define FILE_SYSTEM_H

#include "INode.h"
#include "Buf.h"
#include "BufferManager.h"

/*
 * ļϵͳ洢Դ(Super Block)Ķ塣
 */
class SuperBlock
{
	/* Functions */
public:
	/* Constructors */
	SuperBlock();
	/* Destructors */
	~SuperBlock();
	
	/* Members */
public:
	int		s_isize;		/* Inodeռõ̿ */
	int		s_fsize;		/* ̿ */
	
	int		s_nfree;		/* ֱӹĿ̿ */
	int		s_free[100];	/* ֱӹĿ̿ */
	
	int		s_ninode;		/* ֱӹĿInode */
	int		s_inode[100];	/* ֱӹĿInode */
	
	int		s_flock;		/* ̿־ */
	int		s_ilock;		/* Inode־ */
	
	int		s_fmod;			/* ڴsuper block޸ı־ζҪӦSuper Block */
	int		s_ronly;		/* ļϵͳֻܶ */
	int		s_time;			/* һθʱ */
	int		padding[47];	/* ʹSuperBlockС1024ֽڣռ2 */
};


/*
 * ļϵͳװ(Mount)Ķ塣
 * װʵļϵͳ
 * ļϵͳӡ
 */
class Mount
{
	/* Functions */
public:
	/* Constructors */
	Mount();
	/* Destructors */
	~Mount();
	
	/* Members */
public:
	short 		m_dev;		/* ļϵͳ豸 */
	SuperBlock* m_spb;		/* ָļϵͳSuper Blockڴеĸ */
	Inode*		m_inodep;	/* ָļϵͳڴINode */
};



/*
 * ļϵͳ(FileSystem)ļ洢豸
 * ĸ洢Դ̿顢INodeķ䡢
 * ͷš
 */
class FileSystem
{
public:
	/* static consts */
	static const int NMOUNT = 5;			/* ϵͳڹļϵͳװ */

	static const int SUPER_BLOCK_SECTOR_NUMBER = 400;	/* SuperBlockλڴϵţռ400401 */

	static const int ROOTINO = 1;			/* ļϵͳĿ¼Inode */

	static const int INODE_NUMBER_PER_SECTOR = 8;		/* INode󳤶Ϊ64ֽڣÿ̿Դ512/64 = 8Inode */
	static const int INODE_ZONE_START_SECTOR = 402;		/* Inodeλڴϵʼ */
	static const int INODE_ZONE_SIZE = 1224 - 402;		/* Inodeռݵ */

	static const int DATA_ZONE_START_SECTOR = 1224;		/* ʼ */
	static const int DATA_ZONE_END_SECTOR = 18200 - 1;	/* Ľ */
	static const int DATA_ZONE_SIZE = 18200 - DATA_ZONE_START_SECTOR;	/* ռݵ */

	/* Functions */
public:
	/* Constructors */
	FileSystem();
	/* Destructors */
	~FileSystem();

	/* 
	 * @comment ʼԱ
	 */
	void Initialize();

	/* 
	* @comment ϵͳʼʱSuperBlock
	*/
	void LoadSuperBlock();

	/* 
	 * @comment ļ洢豸豸devȡ
	 * ļϵͳSuperBlock
	 */
	SuperBlock* GetFS(short dev);
	/* 
	 * @comment SuperBlockڴ渱µ
	 * 洢豸SuperBlockȥ
	 */
	void Update();

	/* 
	 * @comment  ڴ洢豸devϷһ
	 * INodeһڴµļ
	 */
	Inode* IAlloc(short dev);
	/* 
	 * @comment  ͷŴ洢豸devϱΪnumber
	 * INodeһɾļ
	 */
	void IFree(short dev, int number);

	/* 
	 * @comment ڴ洢豸devϷд̿
	 */
	Buf* Alloc(short dev);
	/* 
	 * @comment ͷŴ洢豸devϱΪblknoĴ̿
	 */
	void Free(short dev, int blkno);

	/* 
	 * @comment ļϵͳװָInodeӦMountװ
	 */
	Mount* GetMount(Inode* pInode);

private:
	/* 
	 * @comment 豸devϱblknoĴ̿Ƿ
	 * ̿
	 */
	bool BadBlock(SuperBlock* spb, short dev, int blkno);

	/* Members */
public:
	Mount m_Mount[NMOUNT];		/* ļϵͳװMount[0]ڸļϵͳ */

private:
	BufferManager* m_BufferManager;		/* FileSystemҪģ(BufferManager)ṩĽӿ */
	int updlock;				/* Update()úͬڴSuperBlockԼ
								޸ĹڴInodeһʱֻһ̵øú */
};

#endif
