#ifndef INODE_H
#define INODE_H

#include "Buf.h"

/*
 * ڴڵ(INode)Ķ
 * ϵͳÿһ򿪵ļǰĿ¼
 * صļϵͳӦΨһڴinode
 * ÿڴinodeͨinodeڴ洢豸豸(i_dev)
 * Լ豸inodeеı(i_number)ȷ
 * Ӧinode
 */
class Inode
{
public:
	/* i_flagб־λ */
	enum INodeFlag
	{
		ILOCK = 0x1,		/* ڵ */
		IUPD  = 0x2,		/* ڴinode޸ĹҪӦinode */
		IACC  = 0x4,		/* ڴinodeʹҪ޸һηʱ */
		IMOUNT = 0x8,		/* ڴinodeڹļϵͳ */
		IWANT = 0x10,		/* нڵȴڴinodeILOCK־ʱҪֽ */
		ITEXT = 0x20		/* ڴinodeӦͼĶ */
	};
	
	/* static const member */
	static const unsigned int IALLOC = 0x8000;		/* ļʹ */
	static const unsigned int IFMT = 0x6000;		/* ļ */
	static const unsigned int IFDIR = 0x4000;		/* ļͣĿ¼ļ */
	static const unsigned int IFCHR = 0x2000;		/* ַ豸ļ */
	static const unsigned int IFBLK = 0x6000;		/* 豸ļΪ0ʾļ */
	static const unsigned int ILARG = 0x1000;		/* ļͣͻļ */
	static const unsigned int ISUID = 0x800;		/* ִʱļʱûЧûID޸ΪļߵUser ID */
	static const unsigned int ISGID = 0x400;		/* ִʱļʱûЧID޸ΪļߵGroup ID */
	static const unsigned int ISVTX = 0x200;		/* ʹúȻλڽϵĶ */
	static const unsigned int IREAD = 0x100;		/* ļĶȨ */
	static const unsigned int IWRITE = 0x80;		/* ļдȨ */
	static const unsigned int IEXEC = 0x40;			/* ļִȨ */
	static const unsigned int IRWXU = (IREAD|IWRITE|IEXEC);		/* ļļĶдִȨ */
	static const unsigned int IRWXG = ((IRWXU) >> 3);			/* ļͬûļĶдִȨ */
	static const unsigned int IRWXO = ((IRWXU) >> 6);			/* ûļĶдִȨ */
	
	static const int BLOCK_SIZE = 512;		/* ļ߼С: 512ֽ */
	static const int ADDRESS_PER_INDEX_BLOCK = BLOCK_SIZE / sizeof(int);	/* ÿ()̿ */

	static const int SMALL_FILE_BLOCK = 6;	/* СļֱѰַ߼ */
	static const int LARGE_FILE_BLOCK = 128 * 2 + 6;	/* ļһμѰַ߼ */
	static const int HUGE_FILE_BLOCK = 128 * 128 * 2 + 128 * 2 + 6;	/* ļμѰַļ߼ */

	static const int PIPSIZ = SMALL_FILE_BLOCK * BLOCK_SIZE;

	/* static member */
	static int rablock;		/* ˳ʱʹԤļһַ飬rablock¼һ߼
							bmapתõ̿šrablockΪ̬ԭ򣺵һbmapĿ
							ԵǰԤ߼Žתbmapصǰ̿ţҽԤ
							̿űrablockС */
	
	/* Functions */
public:
	/* Constructors */
	Inode();
	/* Destructors */
	~Inode();
	
	/* 
	 * @comment Inodeе̿ȡӦ
	 * ļ
	 */
	void ReadI();
	/* 
	 * @comment Inodeе̿дļ
	 */
	void WriteI();
	/* 
	 * @comment ļ߼תɶӦ̿
	 */
	int Bmap(int lbn);
	
	/* 
	 * @comment ַ豸豸ļø豸עڿ豸ر
	 * е豸ʼ
	 */
	void OpenI(int mode);
	/* 
	 * @comment ַ豸豸ļԸ豸üΪ0
	 * ø豸Ĺرճ
	 */
	void CloseI(int mode);
	
	/* 
	 * @comment Inodeķʱ䡢޸ʱ
	 */
	void IUpdate(int time);
	/* 
	 * @comment ͷInodeӦļռõĴ̿
	 */
	void ITrunc();

	/* 
	 * @comment PipeInodeһȴ˯ߵĽ
	 */
	void Prele();

	/* 
	 * @comment PipePipeѾIWANT־˯ߵȴֱ
	 */
	void Plock();

	/*
	 * @comment PipeInodeһȴ˯ߵĽ
	 */
	void NFrele();

	/*
	 * @comment PipePipeѾIWANT־˯ߵȴֱ
	 */
	void NFlock();

	/* 
	 * @comment Inodeе
	 */
	void Clean();
	/* 
	 * @comment InodeַϢڴInode
	 */
	void ICopy(Buf* bp, int inumber);
	
	/* Members */
public:
	unsigned int i_flag;	/* ״̬ı־λenum INodeFlag */
	unsigned int i_mode;	/* ļʽϢ */
	
	int		i_count;		/* ü */
	int		i_nlink;		/* ļļĿ¼вͬ· */
	
	short	i_dev;			/* inodeڴ洢豸豸 */
	int		i_number;		/* inodeеı */
	
	short	i_uid;			/* ļߵûʶ */
	short	i_gid;			/* ļߵʶ */
	
	int		i_size;			/* ļСֽΪλ */
	int		i_addr[10];		/* ļ߼úתĻ */
	
	int		i_lastr;		/* һζȡļ߼ţжǷҪԤ */
};


/*
 * ڵ(DiskINode)Ķ
 * Inodeλļ洢豸ϵ
 * InodeСÿļΨһӦ
 * InodeǼ¼˸ļ
 * ӦĿϢ
 * InodeֶκڴInodeֶ
 * ӦINode󳤶Ϊ64ֽڣ
 * ÿ̿Դ512/64 = 8Inode
 */
class DiskInode
{
	/* Functions */
public:
	/* Constructors */
	DiskInode();
	/* Destructors */
	~DiskInode();

	/* Members */
public:
	unsigned int d_mode;	/* ״̬ı־λenum INodeFlag */
	int		d_nlink;		/* ļļĿ¼вͬ· */
	
	short	d_uid;			/* ļߵûʶ */
	short	d_gid;			/* ļߵʶ */
	
	int		d_size;			/* ļСֽΪλ */
	int		d_addr[10];		/* ļ߼úתĻ */
	
	int		d_atime;		/* ʱ */
	int		d_mtime;		/* ޸ʱ */
};

#endif
