#ifndef MEMORY_DESCRIPTOR_H
#define MEMORY_DESCRIPTOR_H

#include "PageTable.h"

class MemoryDescriptor
{
public:
	/* ûռС 8M 0x0 - 0x800000 2 PageTable */
	static const unsigned int USER_SPACE_SIZE	= 0x800000; 
	static const unsigned int USER_SPACE_PAGE_TABLE_CNT = 0x2;
	static const unsigned long USER_SPACE_START_ADDRESS		= 0x0;



public:
	MemoryDescriptor();
	~MemoryDescriptor();

public:
	/* 벢ʼPageDirectoryMapǰʹ */
	void Initialize();
	/* ͷŽʱҪøòͷűռõҳ */
	void Release();

	/* ºûɶuserṹҳEntry䣬ҳڽлʱеҳ */
	void MapTextEntrys(unsigned long textStartAddress, unsigned long textSize, unsigned long textPageIdxInPhyMemory);
	void MapDataEntrys(unsigned long dataStartAddress, unsigned long dataSize, unsigned long dataPageIdxInPhyMemory);
	void MapStackEntrys(unsigned long stackSize, unsigned long stackPageIdxInPhyMemory);

	/* @comment ԭunixv6sureg().ԭڽuеuisauisdеڴҳӳӳ䵽UISAUISD
	 * Ĵ.ϵṹĹϵʹMapToPageTable()MemoryDescriptorеҳcopyϵͳʹõ
	 * PageTableУȻʹFlushPageDirectory()ҳӳ䣬̵̨ûӳ */
	void MapToPageTable();
	void NMapToPageTable();//ʹҳҳ
	/* 
	 * @comment ԭunix v6estabur()ڽûַ̬ռԵַӳȻ
	 * MapToPageTable()Եַӳصû̬ҳС
	 */
	bool EstablishUserPageTable(unsigned long textVirtualAddress, unsigned long textSize, unsigned long dataVirtualAddress, unsigned long dataSize, unsigned long stackSize);
	void ClearUserPageTable();
	PageTable* GetUserPageTableArray();
	unsigned long GetTextStartAddress();
	unsigned long GetTextSize();
	unsigned long GetDataStartAddress();
	unsigned long GetDataSize();
	unsigned long GetStackSize();

private:

	/* @commentҳĿ¼
	 * @param
	 * unsigned long virtualAddress:	ַ(ֽΪλ) 
	 * unsigned int size:				ҪӳַС(ֽΪλ) 
	 * unsigned long phyPageIdx:		ʵҳ(ҳΪλ)		
	 * bool isReadWrite:				ҳԣtrueΪɶдҳ
	 */
	unsigned int MapEntry(unsigned long virtualAddress, unsigned int size, unsigned long phyPageIdx, bool isReadWrite);
	
public:
	PageTable*		m_UserPageTableArray;
	/* ݶԵַ */
	unsigned long	m_TextStartAddress;	/* ʼַ */
	unsigned long	m_TextSize;			/* γ */

	unsigned long	m_DataStartAddress; /* ݶʼַ */
	unsigned long	m_DataSize;			/* ݶγ */

	unsigned long	m_StackSize;		/* ջγ */
	//unsigned long	m_HeapSize;			/* Ѷγ */
};

#endif

