#ifndef PAGE_MANAGER_H
#define PAGE_MANAGER_H

#include "MapNode.h"
#include "Allocator.h"

class PageManager
{
public:
	/* static member */
	static unsigned int PHY_MEM_SIZE;	/* ڴСϵͳʱڴС */
	
	/* static const member */
	static const unsigned int PAGE_SIZE = 0x1000;					/* ڴҳС */
	static const unsigned int MEMORY_MAP_ARRAY_SIZE = 0x200;		/* ɷ512 */
	static const unsigned int KERNEL_MEM_START_ADDR	= 0x100000;		/* ںӳ1Mڴ濪ʼ */
	static const unsigned int KERNEL_SIZE			= 0x80000;		/* ںӳС(һӳԶᵽ512KС) */

	/* Functions */
public:
	PageManager(Allocator* allocator);
	virtual ~PageManager();
	
	/* ɶMapNode map[]ĳʼ */
	int Initialize();
	/* 
	 * ڴ
	 * 
	 * size: ڴС(λ: byte)ʵʷڴСҳ
	 * ΪλsizeС4KΪ߽磬ȡ4Kֽ
	 * 
	 * ֵ: ɹڴʼַ0ʾʧܡ
	 */
	unsigned long AllocMemory(unsigned long size);
	/* 
	 * ڴͷ
	 * 
	 * size: ͷڴС(λ: byte)ʵͷڴСҳ
	 * ΪλsizeС4KΪ߽磬ȡ4Kֽ
	 * 
	 * ֵ: ͷڴܳɹͨ䷵ֵ
	 */
	unsigned long FreeMemory(unsigned long size, unsigned long memoryStartAddress);

private:
	PageManager();

	/* Members */
public:
	MapNode map[PageManager::MEMORY_MAP_ARRAY_SIZE];

private:
	Allocator* m_pAllocator;
};


class KernelPageManager : public PageManager
{
public:
	/* 
	 * ַ 0x200000 PageDirectory, 
	 * ַ 0x201000 ںҳ, 
	 * ַ 0x202000  0x203000 ûҳ.
	 */
	static const unsigned int KERNEL_PAGE_POOL_START_ADDR = 0x200000 + 0x2000 + 0x2000;
	static const unsigned int KERNEL_PAGE_POOL_SIZE = 0x200000 - 0x4000;

public:
	KernelPageManager(Allocator* allocator);
	int Initialize();	/* ʼMapNode map[0]ΪںҳʼַС */
};


class UserPageManager : public PageManager
{
public:
	/* static const member */
	static const unsigned int USER_PAGE_POOL_START_ADDR = 0x400000;		/* ûڴʼַ */
	/* static member */
	static unsigned int USER_PAGE_POOL_SIZE;		/* ûڴСں˳ʼʱ */
	
public:
	UserPageManager(Allocator* allocator);
	int Initialize();	/* ʼMapNode map[0]ΪûҳʼַС */
};

#endif
