#ifndef PROCESS_MANAGER_H
#define PROCESS_MANAGER_H

#include "Process.h"
#include "Assembly.h"

/* 
 * espebpuṹĺ꣬ҪNewProc()Swtch()
 * ֻʹúꡣ򣬷صַSaveU()ʱĵַ
 * صSaveU()һִСýǲȷ
 */
 /*
#define SaveU(u) \
	__asm__ __volatile__(	\
		"movl %%esp, %0\n\t \
		 movl %%ebp, %1\n\t" \
		:"+m"((u).u_rsav[0]),"+m"((u).u_rsav[1]) \
		); 
*/

#define SaveU(u_sav) \
	__asm__ __volatile__(	\
		"movl %%esp, %0\n\t \
		 movl %%ebp, %1\n\t" \
		:"+m"(u_sav[0]),"+m"(u_sav[1]) \
		); 
		
/* 
 * ˢںҳ1023ĺ꣬ڽ̵ʱ̵ָָuַʹ
 * GetUser()صǰ̵uṹ
 */
#define SwtchUStruct(p) \
	Machine::Instance().GetKernelPageTable().m_Entrys[Kernel::USER_PAGE_INDEX].m_PageBaseAddress \
		= (p)->p_addr / PageManager::PAGE_SIZE; \
	FlushPageDirectory();

/* 
 * ָespebpuṹĺ꣬ʹúͬSaveU()
 */
/* #define RetU(u) \
	__asm__ __volatile__( \
		"movl %0, %%ebp\n\t \
		 movl %1, %%esp\n\t" \
		: \
		:"m"((u).u_rsav[1]),"m"((u).u_rsav[0]) \
		);	\
	FlushPageDirectory(); 
 */

#define RetU()	\
	__asm__ __volatile__("	movl %0, %%eax;				\
							movl (%%eax), %%esp;		\
							movl 0x4(%%eax), %%ebp;"	\
							:							\
							: "i" (0xc03ff000) );

#define aRetU(u_sav) \
	__asm__ __volatile__("	movl %0, %%esp;			\
							movl %1, %%ebp;"		\
							:						\
							:"m"(u_sav[0]), "m"(u_sav[1]) );
	
class ProcessManager
{
	/* static consts */
public:
	static const int NPROC = 100;
	static const unsigned long PROCESS_ZERO_PPDA_ADDRESS = 0x400000 - 0x1000;

	static const int NTEXT = 50;

	static const int NEXEC = 10;

	static const unsigned int USIZE = 0x1000;	/* ppdaСֽΪλ */

	/* 
	 * ̽˯״̬ʱں˸˯ԭ
	 * СΪȨ˯ߣΪȨ˯ߡ
	 */
	static const int PSWP = -100;
	static const int PINOD = -90;
	static const int PRIBIO = -50;
	static const int EXPRI = -1;
	static const int PPIPE = 1;
	static const int TTIPRI = 10;
	static const int TTOPRI = 20;
	static const int PWAIT = 40;
	static const int PSLEP = 90;
	static const int PUSER = 100;

	/* Functions */
public:
	/* Constructors */
	ProcessManager();
	/* Destructors */
	~ProcessManager();

	void Initialize();

	/* ֹϵͳ0#̶̣ͨfork()0# */
	void SetupProcessZero();

	/*
	 * Swtch()м0#̨󣬵ô˺ѡ
	 * ʺ̨еĽ
	 */
	Process* Select();

	/*
	 * @comment ɵǰн̵Ŀӡ̷ֵΪ0.
	 * ӽڱȺ󷵻1,ָӽ̵Ψһ
	 * ,ӽҪȺ
	 *
	 */
	int NewProc();

	int Swtch();

	/* 
	 * ͼڴͽ֮Ĵ͡нҪڴ棬ڴ
	 * ޷ҵܹɸý̵ڴνȨ˯״̬(SWAIT)-->
	 * ͣ״̬(SSTOP)-->Ȩ˯״̬(SSLEEP)-->״̬(SRUN)̻
	 * ֱڳ㹻ڴռ佫ҪĽ̵ڴ
	 */
	void Sched();

	/* 
	 * ̵ȴӽ̽Wait()ϵͳ
	 */
	void Wait();

	/* 
	* ̴Fork()ϵͳ
	*/
	void Fork();

	/* 
	 * @comment Exec()ϵͳãͼĻ
	 */
	void Exec();

	/* 
	 * ֹKill()ϵͳ
	 */
	void Kill();

	/*
	 * ϵͳchan˯ߵĽ
	 */
	void WakeUpAll(unsigned long chan);

	/*
	 * ̴ڴ滻̽
	 * pProcess: ָҪĽ
	 * bFreeMemory: ǷͷŽͼռݵڴ
	 * size: Ķ⣬̿ɽͼ񳤶ȣsizeΪ0ʱֱʹp_size
	 */
	void XSwap(Process* pProcess, bool bFreeMemory, int size);

	/*
	 * źsignal뷢ͽͬһն˵н
	 */
	void Signal(TTy* pTTy, int signal);

	/* Members */
public:
	Process process[NPROC];
	Text text[NTEXT];

	int CurPri;		/* ռCPUʱ */
	int RunRun;		/* ǿȵȱ־ */
	int RunIn;		/* ڴ޺ʽ̿Ե̽ */
	int RunOut;		/* ̽޽̿Եڴ */
	int ExeCnt;		/* ͬʱͼĻĽ */
	int SwtchNum;	/* ϵͳнл */

private:
	static unsigned int m_NextUniquePid;
public:
	static unsigned int NextUniquePid();

};

#endif

