#include "Exception.h"
#include "Kernel.h"
#include "Utility.h"
#include "Video.h"
#include "Machine.h"

/* 
 * INT 0 - INT 31쳣IDTеں(Entrance)
 * -->޳<-- 쳣
 */
#define IMPLEMENT_EXCEPTION_ENTRANCE(Exception_Entrance, Exception_Handler) \
void Exception::Exception_Entrance() \
{ \
	SaveContext();			\
							\
	SwitchToKernel();		\
							\
	CallHandler(Exception, Exception_Handler);	\
							\
	RestoreContext();		\
							\
	Leave();				\
							\
	InterruptReturn();		\
}

/* 
 * INT 0 - INT 31쳣IDTеں(Entrance)
 * -->г(ErrCode)<-- 쳣
 * ڳiretжϷָ֮ǰֶջϵ
 * г£leaveָջ֡
 * ջϵ4ֽڳ롣
 */
#define IMPLEMENT_EXCEPTION_ENTRANCE_ERRCODE(Exception_Entrance, Exception_Handler) \
void Exception::Exception_Entrance() \
{ \
	SaveContext();			\
							\
	SwitchToKernel();		\
							\
	CallHandler(Exception, Exception_Handler);	\
							\
	RestoreContext();		\
							\
	Leave();				\
							\
	__asm__ __volatile__("addl $4, %%esp" ::);	\
							\
	InterruptReturn();		\
}

/*
	=========================
	һ˵
	=========================
	ĿǰIMPLEMENT_EXCEPTION_ENTRANCE_ERRCODEIMPLEMENT_EXCEPTION_ENTRANCEвõĶ
	Inline Assemblyûκʱֲ(int i, j;֮)ߺãں(Entrance)гջѹ
	ebp֮⣬ûջϷκζֽڣͿܳ
	
	EFLAGS
	CS
	EIP
	[ERRORCODE]	//Optional
	ebp
	xxֽڿռ  	<--ʱֲռõĶջռ䡰  
	SaveContext();
	
	ᵼĳһṹ壬pt_regsͨüĴ(eax,ebx...)ERRORCODEeipcseflagsȫֶΣ
	ôSaveContext()ֶκERRORCODEeipcseflags֮϶ӦԤֽڵֶ(padding)ṹӦ
	Ԥֽڳȵֶ޷ԤȼõģҳȻźֲٶɱԶȷ
	ǲûֻһṹpt_regsȫֶΣǲpt_regspt_contextֶΣpt_regsͨüĴ
	еֳϢpt_contextжָֳ(eflagscseip[ERRORCODE])⣬SaveContext()ʵ
	У

	=========================
	leaveָһ˵
	=========================
	X86Assemblyʵֶleaveiretָװĺ
	leaveiret2ָкװڵʱһЩ⣬**Entrance()ֱʹúװࡣ	
	X86Assembly::Leave()ķ£
	
	push   %ebp
	mov    %esp,%ebp
	leave  
	pop    %ebp
	ret

	leaveָȼ2ָ: mov %ebp, %esp; pop ebp; ٵǰõջ֡X86Assembly::Leave()еleave
	ָٵǵX86Assembly::Leave()ջ֡Ⲣǵı⣬RestoreContext();֮ʹleaveָĿǣ
	λջebpʱ(쳣ں(Entrance)ɵĵһָѹebp)leaveָʹebpջеԼָespӶ
	쳣ں(Entrance)ջ֡
	ĿǰΨһĽ취ֱInline Assemblyleaveָкװ
	
	=========================
	iretָһ˵
	=========================
	ҪڵջŵԪ:
	SS
	ESP
	EFLAGS
	CS
	EIP	<--  ǰջλ
	
	ſʹiretָжϷأiretָзװX86Assembly::IRet()Ľǣջ£
	SS
	ESP
	EFLAGS
	CS
	EIP	
	ebp	<--  ǰջλã ebpX86Assembly::IRet()һָѹ
	ebpΪջ½iretᷢش󣬴ذebpEIP, EIPCSִiretָϵͳ
*/


/* 
 * INT 0 - INT 31쳣(Handler)2ꡣ
 * 
 * (1)	IMPLEMENT_EXCEPTION_HANDLER_ERRCODE(Exception_Handler, Error_Message, Signal_Value)
 * Ӧгڶʹstruct pte_context* context;
 * 
 * (2)	IMPLEMENT_EXCEPTION_HANDLER(Exception_Handler, Error_Message, Signal_Value)
 * Ӧ޳ڶʹstruct pt_context* context;
 * 
 * ڵڶǰerror_codeĽṹpte_context, û
 * error_codeֶεĽṹpt_context!
 */

#define IMPLEMENT_EXCEPTION_HANDLER(Exception_Handler, Error_Message, Signal_Value) \
void Exception::Exception_Handler(struct pt_regs* regs, struct pt_context* context) \
{	\
	User& u = Kernel::Instance().GetUser();			\
	Process* current = u.u_procp;					\
													\
	if ( (context->xcs & USER_MODE) == USER_MODE )	\
	{												\
		current->PSignal(Signal_Value);				\
		if ( current->IsSig() )						\
			current->PSig(context);					\
	}												\
	else											\
	{												\
		Utility::Panic(Error_Message);				\
	}												\
}

#define IMPLEMENT_EXCEPTION_HANDLER_ERRCODE(Exception_Handler, Error_Message, Signal_Value) \
void Exception::Exception_Handler(struct pt_regs* regs, struct pte_context* context) \
{	\
	User& u = Kernel::Instance().GetUser();			\
	Process* current = u.u_procp;					\
													\
	if ( (context->xcs & USER_MODE) == USER_MODE )	\
	{												\
		current->PSignal(Signal_Value);				\
		if ( current->IsSig() )						\
			current->PSig( (pt_context *)&context->eip );		\
	}												\
	else											\
	{												\
		Utility::Panic(Error_Message);				\
	}												\
}


Exception::Exception()
{
	//NOTHING IS OK
}

Exception::~Exception()
{
	//NOTHING IS OK
}


//(INT 0)
IMPLEMENT_EXCEPTION_ENTRANCE(DivideErrorEntrance, DivideError)
IMPLEMENT_EXCEPTION_HANDLER(DivideError, "Divide Exception!", User::SIGFPE)


//쳣(INT 1)
IMPLEMENT_EXCEPTION_ENTRANCE(DebugEntrance, Debug)
IMPLEMENT_EXCEPTION_HANDLER(Debug, "Debug Exception!", User::SIGTRAP)


//NMIж(INT 2)
IMPLEMENT_EXCEPTION_ENTRANCE(NMIEntrance, NMI)
IMPLEMENT_EXCEPTION_HANDLER(NMI, "Non-maskable Interrupt!", User::SIGNUL)


//Զϵ(INT 3)
IMPLEMENT_EXCEPTION_ENTRANCE(BreakpointEntrance, Breakpoint)
IMPLEMENT_EXCEPTION_HANDLER(Breakpoint, "Breakpoint Exception!", User::SIGTRAP)


//(INT 4)
IMPLEMENT_EXCEPTION_ENTRANCE(OverflowEntrance, Overflow)
IMPLEMENT_EXCEPTION_HANDLER(Overflow, "Overflow Exception!", User::SIGSEGV)


//BOUNDָ쳣(INT 5)
IMPLEMENT_EXCEPTION_ENTRANCE(BoundEntrance, Bound)
IMPLEMENT_EXCEPTION_HANDLER(Bound, "Bound Range Exceeded!", User::SIGSEGV)


//Ч(INT 6)
IMPLEMENT_EXCEPTION_ENTRANCE(InvalidOpcodeEntrance, InvalidOpcode)
IMPLEMENT_EXCEPTION_HANDLER(InvalidOpcode, "Invalid Opcode!", User::SIGILL)


//豸(INT 7)
IMPLEMENT_EXCEPTION_ENTRANCE(DeviceNotAvailableEntrance, DeviceNotAvailable)
IMPLEMENT_EXCEPTION_HANDLER(DeviceNotAvailable, "Device Not Available!", User::SIGSEGV)


//˫ش(INT 8)  *г*
IMPLEMENT_EXCEPTION_ENTRANCE_ERRCODE(DoubleFaultEntrance, DoubleFault)
IMPLEMENT_EXCEPTION_HANDLER_ERRCODE(DoubleFault, "Double Fault Exception!", User::SIGSEGV)


//ЭԽ(INT 9)
IMPLEMENT_EXCEPTION_ENTRANCE(CoprocessorSegmentOverrunEntrance, CoprocessorSegmentOverrun)
IMPLEMENT_EXCEPTION_HANDLER(CoprocessorSegmentOverrun, "Coprocessor Segment Overrun!", User::SIGFPE)


//ЧTSS(INT 10)  *г*
IMPLEMENT_EXCEPTION_ENTRANCE_ERRCODE(InvalidTSSEntrance, InvalidTSS)
IMPLEMENT_EXCEPTION_HANDLER_ERRCODE(InvalidTSS, "Invalid TSS!", User::SIGSEGV)


//β(INT 11)  *г*
IMPLEMENT_EXCEPTION_ENTRANCE_ERRCODE(SegmentNotPresentEntrance, SegmentNotPresent)
IMPLEMENT_EXCEPTION_HANDLER_ERRCODE(SegmentNotPresent, "Segment Not Present!", User::SIGBUS)


//ջδ(INT 12)  *г*
IMPLEMENT_EXCEPTION_ENTRANCE_ERRCODE(StackSegmentErrorEntrance, StackSegmentError)
IMPLEMENT_EXCEPTION_HANDLER_ERRCODE(StackSegmentError, "Stack Segment Error!", User::SIGBUS)


//һ㱣쳣(INT 13)  *г*
IMPLEMENT_EXCEPTION_ENTRANCE_ERRCODE(GeneralProtectionEntrance, GeneralProtection)
IMPLEMENT_EXCEPTION_HANDLER_ERRCODE(GeneralProtection, "General Protection!", User::SIGSEGV)



//ȱҳ쳣(INT 14)  *г*
IMPLEMENT_EXCEPTION_ENTRANCE_ERRCODE(PageFaultEntrance, PageFault)
//IMPLEMENT_EXCEPTION_HANDLER_ERRCODE(PageFault, "Page Fault!", User::SIGSEGV)

void Exception::PageFault(struct pt_regs* regs, struct pte_context* context)
{

	User& u = Kernel::Instance().GetUser();
	Process* current = u.u_procp;
	MemoryDescriptor& md = u.u_MemoryDescriptor;

	unsigned int cr2;
	__asm__ __volatile__(" mov %%cr2, %0":"=r"(cr2) );

    /*ȱҳ쳣ÿչһҳȱ˶Ŷջҳ棬ǾͶִмȱҳ쳣ֱЩҳ油*/

	if( (context->xcs & USER_MODE) == USER_MODE)
	{
		if( cr2 < MemoryDescriptor::USER_SPACE_SIZE - md.m_StackSize && cr2 >= context->esp - 8
				&& md.m_DataSize + md.m_StackSize + PageManager::PAGE_SIZE < MemoryDescriptor::USER_SPACE_SIZE - md.m_DataStartAddress )
			current->SStack();
		else
		{
			Diagnose::Write("Invalid MM access");
			current -> PSignal(User::SIGSEGV);
			if ( current->IsSig() )
				current->PSig( (pt_context *)&context->eip );
		}
	}
	else
		Utility::Panic("Page Fault in Kernel Mode.");
}

//x87 FPU(INT 16)
IMPLEMENT_EXCEPTION_ENTRANCE(CoprocessorErrorEntrance, CoprocessorError)
IMPLEMENT_EXCEPTION_HANDLER(CoprocessorError, "Coprocessor Error!", User::SIGFPE)


//У(INT 17)  *г*
IMPLEMENT_EXCEPTION_ENTRANCE_ERRCODE(AlignmentCheckEntrance, AlignmentCheck)
IMPLEMENT_EXCEPTION_HANDLER_ERRCODE(AlignmentCheck, "Alignment Check!", User::SIGBUS)


//(INT 18)
IMPLEMENT_EXCEPTION_ENTRANCE(MachineCheckEntrance, MachineCheck)
IMPLEMENT_EXCEPTION_HANDLER(MachineCheck, "Machine Check!", User::SIGNUL)


//SIMD쳣(INT 19)
IMPLEMENT_EXCEPTION_ENTRANCE(SIMDExceptionEntrance, SIMDException)
IMPLEMENT_EXCEPTION_HANDLER(SIMDException, "SIMD Float Point Exception!", User::SIGFPE)
