#include "TimeInterrupt.h"
#include "Kernel.h"
#include "Regs.h"
#include "IOPort.h"
#include "Chip8259A.h"
#include "Video.h"

int Time::lbolt = 0;
unsigned int Time::time = 0;
unsigned int Time::tout = 0;

void Time::TimeInterruptEntrance()
{
	SaveContext();			/* жֳ */

	SwitchToKernel();		/* ̬ */

	CallHandler(Time, Clock);		/* ʱжϴӳ */

	/* ȡжָ(Ӳʵʩ)ѹջpt_context
	* ͿԷcontext.xcsеOLD_CPLжǰ̬
	* û̬Ǻ̬
	*/
	struct pt_context *context;
	__asm__ __volatile__ ("	movl %%ebp, %0; addl $0x4, %0 " : "+m" (context) );

	if( context->xcs & USER_MODE ) /*ǰΪû̬*/
	{
		while(true)
		{
			X86Assembly::CLI();	/* ȼΪ7 */
			
			if(Kernel::Instance().GetProcessManager().RunRun > 0)
			{
				X86Assembly::STI();	/* ȼΪ0 */
				Kernel::Instance().GetProcessManager().Swtch();
			}
			else
			{
				break;	/* runrun == 0ջصû̬ûִ */
			}
		}
	}

	RestoreContext();		/* ֳָ */

	Leave();				/* ֹջ֡ */

	InterruptReturn();		/* ˳ж */
}

void Time::Clock( struct pt_regs* regs, struct pt_context* context )
{
	User& u = Kernel::Instance().GetUser();
	ProcessManager& procMgr = Kernel::Instance().GetProcessManager();

	/* ϵͳûʱʱǰ̬Ϊû̬modeΪ */
	if ( (context->xcs & USER_MODE) == USER_MODE )
	{
		u.u_utime++;
	}
	else
	{
		u.u_stime++;
	}

	Process* current = u.u_procp;
	/* 㵱ǰռõCPUʱ */
	current->p_cpu = Utility::Min(++current->p_cpu, 1024);

	/* һĩβǰ̬Ƿн */
	if ( ++Time::lbolt < HZ )
    	{
		/* 8259AжϿоƬEOI */
		    IOPort::OutByte(Chip8259A::MASTER_IO_PORT_1, Chip8259A::EOI);
        	return;
    	}
    else
	{
        /* жǰΪ̬Ѻʱļһʱжٿ */
		/*if( (context->xcs & USER_MODE) == KERNEL_MODE && current->p_pid != 0)*/
    	if( current->p_stat == Process::SRUN && (context->xcs & USER_MODE) == KERNEL_MODE )
		{
			/* 8259AжϿоƬEOI */
			    IOPort::OutByte(Chip8259A::MASTER_IO_PORT_1, Chip8259A::EOI);
        		return;
   		 }

		/* Ϊһĩβкʱļ */
		Time::lbolt -= HZ;

		/* ϵͳȫʱ+1Ϊλ */
		Time::time++;

		/* жϽ룬൱ڽʹȼ */
		X86Assembly::STI();
	    /* 8259AжϿоƬEOI */
	    IOPort::OutByte(Chip8259A::MASTER_IO_PORT_1, Chip8259A::EOI);


		if ( Time::time == Time::tout )
		{
			/* ʱ˯ߵĽ */
			procMgr.WakeUpAll((unsigned long)&Time::tout);
		}

		/* н̵p_time, p_cpu,Լp_pri */
		for( int i = 0; i < ProcessManager::NPROC; i++ )
		{
			Process* pProcess = &procMgr.process[i];
			if ( pProcess->p_stat != Process::SNULL )
			{
				pProcess->p_time = Utility::Min(++pProcess->p_time, 127);
				
				if ( pProcess->p_cpu > SCHMAG )
				{
					pProcess->p_cpu -= SCHMAG;
				}
				else
				{
					pProcess->p_cpu = 0;
				}
				if ( pProcess->p_pri > ProcessManager::PUSER )
				{
					pProcess->SetPri();
					//Diagnose::Write("PID = %d, p_cpu = %d, p_pri = %d\n", pProcess->p_pid, pProcess->p_cpu, pProcess->p_pri);
				}
			}
		}
		//Diagnose::Write("curpri = %d\n", procMgr.CurPri);
		//Diagnose::Write("System Time: %d\n", Time::time);
		
		if ( procMgr.RunIn != 0 )
		{
			procMgr.RunIn = 0;
			procMgr.WakeUpAll((unsigned long)&procMgr.RunIn);
		}

		/* жǰΪû̬ǽźŴ */
		if ( (context->xcs & USER_MODE) == USER_MODE )
		{
			if ( current->IsSig() )
			{
				current->PSig(context);
			}
			/* 㵱ǰ */
			current->SetPri();
		}
	}
}
