#include "Chip8259A.h"
#include "IOPort.h"

void Chip8259A::Init()
{
	/* Initialize 8259A */
	//ICW1ȷƬĹģʽΪ
	//ģʽشҪICW4
	IOPort::OutByte(MASTER_IO_PORT_1, 0x11);
	IOPort::OutByte(SLAVE_IO_PORT_1, 0x11);
	
	//ICW2ȷƬӦж
	IOPort::OutByte(MASTER_IO_PORT_2, MASTER_IRQ_START);
	IOPort::OutByte(SLAVE_IO_PORT_2,  SLAVE_IRQ_START);
	
	//ICW3ȷƬ
	/* TO MASTER:  ƬIR2˴Ƭ,IR2ӦλΪ1 */
	IOPort::OutByte(MASTER_IO_PORT_2, 1 << IRQ_SLAVE); /* 0x04 = 0000 0100b */
	/* TO SLAVE: ƬӵƬIR2, ҪʹD2~D0  2*/
	IOPort::OutByte(SLAVE_IO_PORT_2, IRQ_SLAVE);
	
	//ICW4ȷƬжִģʽ
	//ͨȫǶģʽEOI(End of Interrupt)Intel X86ģʽ
	IOPort::OutByte(MASTER_IO_PORT_2, 0x01);
	IOPort::OutByte(SLAVE_IO_PORT_2, 0x01);
	
	/* ʼ֮ж,дOCW1Ĵ,жλһ֪״̬¡*/
	IOPort::OutByte(MASTER_IO_PORT_2, MASK_ALL);
	IOPort::OutByte(SLAVE_IO_PORT_2,  MASK_ALL);	
	return;
}


void Chip8259A::IrqEnable(unsigned int irq)
{
	/* 
	 * IRQΧ015֮ڣirqunsigned intͣС0ܣ
	 * ʵirqֵӦֻIRQ_TIMERIRQ_KBDѾ
	 * ļIRQţIRQ6ж֮ںвδ漰
	 */
	if(irq >= 16)
		{return; /*.....Ϣ*/}
	
	unsigned char value;
	
	if(irq <= 7) /* 0 <= irq <= 7,  MASTER chipOCW1*/
	{
		// Get ICW1
		value = IOPort::InByte(MASTER_IO_PORT_2);
		value &= ~(1 << irq);
		//Write ICW1 back to 8259A
		IOPort::OutByte(MASTER_IO_PORT_2, value);
	}
	else /*SLAVE chipOCW1*/
	{
		value = IOPort::InByte(SLAVE_IO_PORT_2);
		value &= ~(1 << (irq - 8));
		IOPort::OutByte(SLAVE_IO_PORT_2, value);
	}
	
	return;
}

void Chip8259A::IrqDisable(unsigned int irq)
{
	if(irq >= 16)
		{return; /*.....Ϣ*/}
	
	unsigned char value;
	
	if(irq <= 7)	/* 0 <= irq <= 7,  MASTER chipOCW1*/
	{
		value = IOPort::InByte(MASTER_IO_PORT_2);
		value |= (1 << irq);
		IOPort::OutByte(MASTER_IO_PORT_2, value);
	}
	else /*SLAVE chipOCW1*/
	{
		value = IOPort::InByte(SLAVE_IO_PORT_2);
		value |= (1 << (irq - 8));
		IOPort::OutByte(SLAVE_IO_PORT_2, value);
	}
	return;
}
